C************************************************************************
        subroutine gtmc(p,npatt,r,patt,mc,nmc,last)
C Finds the column numbers of the missing variables, and stores them
C in the first nmc elements of mc
        integer p,npatt,r(npatt,p),patt,mc(p),nmc,last
        nmc=0
        do 10 j=1,last
           if(r(patt,j).eq.0)then
              nmc=nmc+1
              mc(nmc)=j
           endif
10      continue
        return
        end
C************************************************************************
        subroutine initc(p,c,mc,nmc)
        integer p,c(p),mc(p),nmc
        do 1 j=1,nmc
           c(mc(j))=1
1       continue
        return
        end
C************************************************************************
        subroutine gtdmis(p,d,mc,nmc,dmis)
        integer p,d(p),mc(p),nmc,dmis
        dmis=1
        do 1 j=1,nmc
           dmis=dmis*d(mc(j))
1       continue
        return
        end
C************************************************************************
        subroutine advc(p,c,d,mc,nmc)
C Advances c to next value
        integer p,c(p),d(p),mc(p),nmc
        do 1 j=1,nmc
           if(c(mc(j)).lt.d(mc(j)))then
              c(mc(j))=c(mc(j))+1
              goto 2
           else
              c(mc(j))=1
           endif
1       continue
2       continue
        return
        end
C************************************************************************
        subroutine gtmmis(p,c,mc,nmc,jmp,mmis)
C Calculates mmis from c
        integer p,c(p),mc(p),nmc,jmp(p),mmis
        mmis=0
        do 1 j=1,nmc
           mmis=mmis+(c(mc(j))-1)*jmp(mc(j))
1       continue
        return
        end
C************************************************************************
        subroutine sumc(p,c,mc,nmc,d,jmp,mobs0,dmis,ncells,theta,sum)
        integer p,c(p),mc(p),nmc,d(p),jmp(p),mobs0
        integer m,mmis,dmis,ncells
        double precision sum,theta(ncells)
        call initc(p,c,mc,nmc)
        sum=0.0d0
        mmis=0
        do 1 i=1,dmis
           if(i.ne.1)then
              call advc(p,c,d,mc,nmc)
              call gtmmis(p,c,mc,nmc,jmp,mmis)
           endif
           m=mobs0+mmis
           sum=sum+theta(m)
1       continue
        return
        end
C************************************************************************
        subroutine estepc(ncells,theta,x,npatt,p,r,mdpgrp,ngrp,mobs,
     /     nmobs,d,jmp,err,c,mc)
C Performs E-step of EM algorithm. Allocates partially observed data
C to cells of x under specified value of theta.
C If a partially observed unit appears in a cell for which the
C margin of theta is zero, then err is set to one.
C Note: elements of theta need not sum to one.
        integer ncells,npatt,p,r(npatt,p),mdpgrp(npatt),ngrp
        integer mobs(ngrp),nmobs(ngrp),d(p),jmp(p),c(p),mc(p)
        integer patt,grpno,dmis,m,mmis,err,nmc
        double precision sum,theta(ncells),x(ncells)
        do 1 i=1,ncells
           x(i)=0.0d0
1       continue
        err=0
        grpno=0
        do 200 patt=1,npatt
           call gtmc(p,npatt,r,patt,mc,nmc,p)
           if(nmc.eq.0)then
              do 50 k=1,mdpgrp(patt)
                 grpno=grpno+1
                 if(theta(mobs(grpno)).le.0.0d0)then
                    err=1
                    goto 250
                 endif
                 x(mobs(grpno))=x(mobs(grpno))+dfloat(nmobs(grpno))
50            continue
           else
              call gtdmis(p,d,mc,nmc,dmis)
              do 150 k=1,mdpgrp(patt)
                 grpno=grpno+1
                 call sumc(p,c,mc,nmc,d,jmp,mobs(grpno),dmis,
     /                ncells,theta,sum)
                 if(sum.le.0.0d0)then
                    err=1
                    goto 250
                 endif
                 call initc(p,c,mc,nmc)
                 mmis=0
                 do 130 i=1,dmis
                    if(i.ne.1)then
                       call advc(p,c,d,mc,nmc)
                       call gtmmis(p,c,mc,nmc,jmp,mmis)
                    endif
                    m=mobs(grpno)+mmis
                    x(m)=x(m)+dfloat(nmobs(grpno))*theta(m)/sum
130              continue
150           continue
           endif
200     continue
250     continue
        return
        end
C************************************************************************
        subroutine istepc(ncells,theta,x,npatt,p,r,mdpgrp,ngrp,mobs,
     /     nmobs,d,jmp,err,c,mc)
C Performs I-step of DA algorithm. Allocates partially observed data
C to cells of x at random under specified value of theta.
C If a partially observed unit appears in a cell for which the
C margin of theta is zero, then err is set to one.
C Note: Elements of theta need not sum to one.
        integer ncells,npatt,p,r(npatt,p),mdpgrp(npatt),ngrp
        integer mobs(ngrp),nmobs(ngrp),d(p),jmp(p),c(p),mc(p)
        integer patt,grpno,dmis,m,mmis,err,nmc
        double precision sum,theta(ncells),x(ncells),sum1,u
        do 1 i=1,ncells
           x(i)=0.0d0
1       continue
        err=0
        grpno=0
        do 200 patt=1,npatt
           call gtmc(p,npatt,r,patt,mc,nmc,p)
           if(nmc.eq.0)then
              do 50 k=1,mdpgrp(patt)
                 grpno=grpno+1
                 if(theta(mobs(grpno)).le.0.0d0)then
                    err=1
                    goto 250
                 endif
                 x(mobs(grpno))=x(mobs(grpno))+dfloat(nmobs(grpno))
50            continue
           else
              call gtdmis(p,d,mc,nmc,dmis)
              do 150 k=1,mdpgrp(patt)
                 grpno=grpno+1
                 call sumc(p,c,mc,nmc,d,jmp,mobs(grpno),dmis,
     /                ncells,theta,sum)
                 if(sum.le.0.0d0)then
                    err=1
                    goto 250
                 endif
C Distribute data at random
                 do 140 l=1,nmobs(grpno)
                    call initc(p,c,mc,nmc)
                    mmis=0
                    u=dble(rangen(0))
                    sum1=0
                    do 130 i=1,dmis
                       if(i.ne.1)then
                          call advc(p,c,d,mc,nmc)
                          call gtmmis(p,c,mc,nmc,jmp,mmis)
                       endif
                       m=mobs(grpno)+mmis
                       sum1=sum1+(theta(m)/sum)
                       if((sum1.gt.u).or.(i.eq.dmis))then
                          x(m)=x(m)+1.0d0
                          goto 135
                       endif
130                 continue
135                 continue
140              continue
150           continue
           endif
200     continue
250     continue
        return
        end
C************************************************************************
        subroutine pstep1c(ncells,x,theta,err)
C Performs posterior step of DA. Draws a value theta from
C the Dirichlet posterior distribution of theta, given updated 
C hyperparameters in x. Structural zeroes are 
C flagged by x=-999 and set to zero.
C If any element of x is <= 0 but not -999, then err
C is set to one.
        integer ncells,err
        double precision sum,x(ncells),theta(ncells)
        err=0
        sum=0.0d0
        do 5 i=1,ncells
           if(x(i).ne.dfloat(-999))then
              if(x(i).le.0.0d0)then
                 err=1
                 goto 15
              else
                 theta(i)=dble(gamm(sngl(x(i))))
              endif
              sum=sum+theta(i)
           endif
5       continue
        do 10 i=1,ncells
           if(x(i).ne.dfloat(-999))then
              theta(i)=theta(i)/sum
           else
              theta(i)=0.0d0
           endif
10      continue
 15     continue
        return
        end
C************************************************************************
        subroutine llc(ncells,theta,npatt,p,r,mdpgrp,
     /     ngrp,mobs,nmobs,d,jmp,c,mc,ll,err)
C Calculates observed-data loglikelihood function. If a nonzero
C count appears in a cell for which the probability implied by 
C theta is zero, then sets err=1.
        integer ncells,npatt,p,r(npatt,p),mdpgrp(npatt),ngrp
        integer mobs(ngrp),nmobs(ngrp),d(p),jmp(p)
        integer dmis,patt,c(p),mc(p),grpno,nmc,err
        double precision sum,ll,tmp,theta(ncells)
        err=0
        ll=0.0d0
        grpno=0
        do 200 patt=1,npatt
           call gtmc(p,npatt,r,patt,mc,nmc,p)
           call gtdmis(p,d,mc,nmc,dmis)
           do 150 k=1,mdpgrp(patt)
              grpno=grpno+1
              call sumc(p,c,mc,nmc,d,jmp,mobs(grpno),dmis,
     /             ncells,theta,sum)
              tmp=dfloat(nmobs(grpno))
              if(sum.le.0.0d0)then
                 err=1
                 goto 250
              else
                 ll=ll+tmp*log(sum)
              endif
150        continue
200     continue
250     continue
        return
        end
C************************************************************************
        subroutine impc(n,p,x,ncells,theta,npatt,r,mdpgst,mdpgrp,
     /     ngrp,mobs,nmobs,mobsst,d,jmp,c,mc)
C Performs imputation of missing data under theta. Result is
C a completed data matrix x.
        integer n,p,x(n,p),ncells,npatt,mdpgst(npatt)
        integer r(npatt,p),mdpgrp(npatt),ngrp,mobs(ngrp)
        integer nmobs(ngrp),mobsst(ngrp),d(p),jmp(p),mc(p)
        integer dmis,patt,c(p),grpno,mmis,m,drow,dcol,nmc
        double precision sum,sum1,theta(ncells),u
        do 200 patt=1,npatt
           call gtmc(p,npatt,r,patt,mc,nmc,p)
           call gtdmis(p,d,mc,nmc,dmis)
           if(nmc.gt.0)then
C Find the conditional disn of Xmis given Xobs
              do 150 grpno=mdpgst(patt),(mdpgst(patt)+
     /           mdpgrp(patt)-1)
                 call sumc(p,c,mc,nmc,d,jmp,mobs(grpno),dmis,
     /                ncells,theta,sum)
C Distribute data at random
                 drow=mobsst(grpno)-1
                 do 140 l=1,nmobs(grpno)
                    drow=drow+1
                    call initc(p,c,mc,nmc)
                    mmis=0
                    u=dble(rangen(0))
                    sum1=0
                    do 130 i=1,dmis
                       if(i.ne.1)then
                          call advc(p,c,d,mc,nmc)
                          call gtmmis(p,c,mc,nmc,jmp,mmis)
                       endif
                       m=mobs(grpno)+mmis
                       sum1=sum1+(theta(m)/sum)
                       if((sum1.gt.u).or.(i.eq.dmis))then
                          do 95 dcol=1,nmc
                             x(drow,mc(dcol))=c(mc(dcol))
95                        continue  
                          goto 135
                       endif
130                 continue
135                 continue
140              continue
150           continue
           endif   
200     continue
        return
        end
C************************************************************************
        function rangen(init)
        integer a,p,ix,b15,b16,xhi,xalo,leftflo,fhi,k,init
        data a/16807/,b15/32768/,b16/65536/,p/2147483647/
        save ix
        if(init.ne.0) ix=init
        xhi=ix/b16
        xalo=(ix-xhi*b16)*a
        leftflo=xalo/b16
        fhi=xhi*a+leftflo
        k=fhi/b15
        ix=(((xalo-leftflo*b16)-p)+(fhi-k*b15)*b16)+k
        if (ix.lt.0)ix=ix+p
        rangen=float(ix)*4.656612875E-10
        return
        end
C***********************************************************************
        subroutine rngs(seed)
C initializes rangen with seed
        integer seed
        tmp=rangen(seed)
        return
        end
C***********************************************************************
        function gamm(a)
C Generates a random gamma(a) variate. If a>=1, uses the method of 
C Fishman (1976); if 0<a<1, the method of Ahrens (1974)
        real a,u,y,q,e,b,p,u1,lq
        data e/2.718282/
        if(a.ge.1)then
1          continue
           u=rangen(0)
           y=-log(rangen(0))
C           q=(y/exp(y-1))**(a-1)
           lq=(a-1.)*(log(y)-(y-1.))
           q=exp(lq)
           if(u.le.q)then
              gamm=a*y
           else
              goto 1
           endif
        else
2          continue
           u=rangen(0)
           b=(e+a)/e
           p=b*u
           if(p.gt.1) goto 4
3          continue
           x=p**(1/a)
           u1=rangen(0)
           if(u1.gt.(e**(-x)))then
              goto 2
           else
              gamm=x
              goto 10
           endif
4          continue
           x=-log((b-p)/a)
           u1=rangen(0)
           if(u1.gt.(x**(a-1)))then
              goto 2
           else
              gamm=x
              goto 10
           endif
        endif
10      continue
        return
        end
C***********************************************************************
        subroutine mgstepc(ncells,oldtheta,newtheta,npatt,p,r,mdpgrp,
     /     ngrp,mobs,nmobs,d,jmp,c,mc,dtable,prior,err,sj)
C Performs one step of monotone DA. Randomly allocates partially 
C observed data to cells of newtheta, assuming that theta=oldtheta.
C A structural zero is indicated by oldtheta=0 and prior=-999.
C If any observation is allocated to a structural or random zero in the
C I-step, sets err to one. This indicates that the observed data are
C inconsistent with the starting value and/or prior.
C If any prior count + cell count < 0, sets err to one.
C If posterior is improper, sets err to 2.
        integer ncells,npatt,p,r(npatt,p),mdpgrp(npatt),ngrp
        integer mobs(ngrp),nmobs(ngrp),d(p),jmp(p)
        integer dmis,patt,c(p),mc(p),grpno,mmis,m,nmc,lp,fp
        integer outer,inner,ii,jmpii,nii,mii,err,sj(p),zflag
        double precision oldtheta(ncells),newtheta(ncells)
        double precision prior(ncells),u,sum,sum1,sum2,dtable(ncells)
        err=0
C put prior counts in dtable, initialize newtheta to all ones
        do 5 i=1,ncells
           dtable(i)=prior(i)
           newtheta(i)=1.0d0
5       continue
        grpno=0
        do 400 j=p,1,-1
           if(j.eq.p) then
              fp=1
           else
              fp=sj(j+1)+1
           endif
           lp=sj(j)
C do the I-step
           do 200 patt=fp,lp
              call gtmc(p,npatt,r,patt,mc,nmc,j)
              call gtdmis(p,d,mc,nmc,dmis)
C Find the conditional disn of Ymis* given Yobs
              do 150 k=1,mdpgrp(patt)
                 grpno=grpno+1
                 call sumc(p,c,mc,nmc,d,jmp,mobs(grpno),dmis,
     /             ncells,oldtheta,sum)
C Distribute data at random by table sampling
                 do 140 l=1,nmobs(grpno)
                    call initc(p,c,mc,nmc)
                    mmis=0
                    u=dble(rangen(0))
                    sum1=0.0d0
                    do 130 i=1,dmis
                       if(i.ne.1)then
                          call advc(p,c,d,mc,nmc)
                          call gtmmis(p,c,mc,nmc,jmp,mmis)
                       endif
                       m=mobs(grpno)+mmis
                       sum1=sum1+(oldtheta(m)/sum)
                       if((sum1.gt.u).or.(i.eq.dmis))then
                          if(oldtheta(m).eq.0.0d0)then
                             err=1
                             goto 450
                          endif
                          dtable(m)=dtable(m)+1.0d0
                          goto 135
                       endif
130                 continue
135                 continue
140              continue
150           continue
200        continue
C Now draw from the jth posterior factor, while collapsing dtable
C and oldtheta
           jmpii=jmp(j)*d(j)
           nii=ncells/jmpii
           do 350 outer=1,jmp(j)
              m=outer-jmp(j)
              sum=0.0d0
              sum1=0.0d0
              sum2=0.0d0
              zflag=1
              do 250 inner=1,d(j)
                 m=m+jmp(j)
                 if(dtable(m).eq.dfloat(-999))then
                    u=0.0d0
                 else
                    if(dtable(m).le.0.0d0)then
                       err=2
                       goto 450
                    else
                       u=dble(gamm(sngl(dtable(m))))
                       zflag=0
                       sum1=sum1+dtable(m)
                    endif
                 endif
                 sum=sum+u
                 sum2=sum2+oldtheta(m)
                 mii=m-jmpii
                 do 230 ii=1,nii
                    mii=mii+jmpii
                    newtheta(mii)=newtheta(mii)*u
230              continue
250           continue
              oldtheta(outer)=sum2
              if(zflag.eq.1)then
                 dtable(outer)=dfloat(-999)
              else
                 dtable(outer)=sum1
              endif
              m=outer-jmp(j)
              do 300 inner=1,d(j)
                 m=m+jmp(j)
                 dtable(m)=sum1
                 mii=m-jmpii
                 do 280 ii=1,nii
                    mii=mii+jmpii
                    newtheta(mii)=newtheta(mii)/sum
280              continue
300           continue
350        continue
400     continue
450     continue
        return
        end
C************************************************************************
        subroutine gtntab(ncon,con,ntab)
C find number of marginal tables to be fit
        integer ncon,con(ncon),ntab,flag,posn
        ntab=0
        flag=0
        do 10 posn=1,ncon
           if((con(posn).ne.0).and.(flag.eq.0))flag=1
           if((con(posn).eq.0).and.(flag.eq.1))then
              ntab=ntab+1
              flag=0
           endif
           if((flag.eq.1).and.(posn.eq.ncon))ntab=ntab+1
10      continue
        return
        end
C************************************************************************
        subroutine gtmarg(ncon,con,posn,p,marg,nmarg)
C extract the next set of margins to be fit, store them in the first 
C nmarg elements of marg. For first set, posn should be 0.
        integer ncon,con(ncon),p,marg(p),nmarg,posn
1       continue
           posn=posn+1
           if(con(posn).eq.0)goto 1
        nmarg=0
11      continue
          if(con(posn).eq.0)goto 12
          nmarg=nmarg+1
          marg(nmarg)=con(posn)
          if(posn.eq.ncon)goto 12
          posn=posn+1
          goto 11
12      continue
        return
        end
C************************************************************************
        subroutine gtrest(p,marg,nmarg,rest,nrest)
        integer p,marg(p),nmarg,rest(p),nrest,flag
        nrest=0
        do 20 j=1,p
           flag=0
           do 10 k=1,nmarg
              if(j.eq.marg(k))then
                 flag=1
                 goto 15
              endif
10         continue
15         continue
           if(flag.eq.0)then
              nrest=nrest+1
              rest(nrest)=j
           endif
20      continue
        return
        end
C************************************************************************
        subroutine ipf(ncells,table,fit,ncon,con,p,d,jmp,c,marg,rest,
     /     eps)
C Performs one step of iterative proportional fitting, raking fit
C to the margins of table. Margins to be fit are specified in con.
        integer ncells,ncon,con(ncon),p,d(p),jmp(p),c(p),marg(p)
        integer rest(p),nmarg,nrest,m,mmarg,mrest,posn,ntab,tabno
        integer out,in,dmarg,drest
        double precision sumt,sumf,table(ncells),fit(ncells),eps
        call gtntab(ncon,con,ntab)
        posn=0
        do 100 tabno=1,ntab
           call gtmarg(ncon,con,posn,p,marg,nmarg)
           call gtrest(p,marg,nmarg,rest,nrest)
           call gtdmis(p,d,marg,nmarg,dmarg)
           drest=ncells/dmarg
           call initc(p,c,marg,nmarg)
           mmarg=1
           do 90 out=1,dmarg
              if(out.ne.1)then
                 call advc(p,c,d,marg,nmarg)
                 call gtmmis(p,c,marg,nmarg,jmp,mmarg)
                 mmarg=mmarg+1
              endif
              call sum2c(p,c,rest,nrest,d,jmp,mmarg,drest,ncells,
     /             table,sumt,fit,sumf)
              call initc(p,c,rest,nrest)
              if(sumf.ne.0)then
                 mrest=0
                 do 80 in=1,drest   
                    if(in.ne.1)then
                       call advc(p,c,d,rest,nrest)
                       call gtmmis(p,c,rest,nrest,jmp,mrest)
                    endif
                    m=mmarg+mrest
                    if(fit(m).ge.eps) then
                       fit(m)=fit(m)*(sumt/sumf)
                    else
                       fit(m)=0.0d0
                    endif
80               continue
              endif
90         continue
100     continue
        return
        end
C************************************************************************
        subroutine bipf(ncells,table,theta,prior,ncon,con,p,d,jmp,c,
     /     marg,rest,err)
C Performs one cycle of Bayesian ipf. Cell counts are in table
C and starting value in theta.  Prior hyperparameters are in prior,
C with structural zeros denoted by -999. Replaces theta with an
C updated value. 
        integer ncells,ncon,con(ncon),p,d(p),jmp(p),c(p),marg(p)
        integer rest(p),nmarg,nrest,m,mmarg,mrest,posn,ntab,tabno
        integer out,in,dmarg,drest,err,zflag
        double precision sumt,sumf,table(ncells),theta(ncells),g
        double precision prior(ncells),sum3
        call gtntab(ncon,con,ntab)
        err=0
        posn=0
        do 100 tabno=1,ntab
           sum3=0.0d0
           call gtmarg(ncon,con,posn,p,marg,nmarg)
           call gtrest(p,marg,nmarg,rest,nrest)
           call gtdmis(p,d,marg,nmarg,dmarg)
           drest=ncells/dmarg
           call initc(p,c,marg,nmarg)
           mmarg=1
           do 90 out=1,dmarg
              if(out.ne.1)then
                 call advc(p,c,d,marg,nmarg)
                 call gtmmis(p,c,marg,nmarg,jmp,mmarg)
                 mmarg=mmarg+1
              endif
              zflag=0
              call sum3c(p,c,rest,nrest,d,jmp,mmarg,drest,ncells,
     /             table,sumt,theta,sumf,prior,zflag)
              call initc(p,c,rest,nrest)
              if(sumt.le.0)then
                 err=1
                 goto 150
              endif
              if(zflag.eq.1)then
                 g=dble(gamm(sngl(sumt)))+dble(1e-20)
                 sum3=sum3+g
              endif
              mrest=0
              do 80 in=1,drest   
                 if(in.ne.1)then
                    call advc(p,c,d,rest,nrest)
                    call gtmmis(p,c,rest,nrest,jmp,mrest)
                 endif
                 m=mmarg+mrest
                 theta(m)=theta(m)*g/sumf
 80           continue
 90        continue
           do 95 m=1,ncells
              theta(m)=theta(m)/sum3
 95        continue
100     continue
150     continue
        return
        end
C************************************************************************
        subroutine sum2c(p,c,mc,nmc,d,jmp,mobs,dmis,
     /      ncells,table1,sum1,table2,sum2)
        integer p,c(p),mc(p),nmc,d(p),jmp(p),mobs
        integer m,mmis,dmis,ncells
        double precision sum1,sum2,table1(ncells),table2(ncells)
        call initc(p,c,mc,nmc)
        sum1=0.0d0
        sum2=0.0d0
        mmis=0
        do 1 i=1,dmis
           if(i.ne.1)then
              call advc(p,c,d,mc,nmc)
              call gtmmis(p,c,mc,nmc,jmp,mmis)
           endif
           m=mobs+mmis
           sum1=sum1+table1(m)
           sum2=sum2+table2(m)
1       continue
        return
        end
C************************************************************************
        subroutine sum3c(p,c,mc,nmc,d,jmp,mobs,dmis,
     /      ncells,table1,sum1,table2,sum2,prior,zflag)
        integer p,c(p),mc(p),nmc,d(p),jmp(p),mobs
        integer m,mmis,dmis,ncells,zflag
        double precision sum1,sum2,table1(ncells),table2(ncells),
     /    prior(ncells)
        call initc(p,c,mc,nmc)
        sum1=0.0d0
        sum2=0.0d0
        mmis=0
        do 1 i=1,dmis
           if(i.ne.1)then
              call advc(p,c,d,mc,nmc)
              call gtmmis(p,c,mc,nmc,jmp,mmis)
           endif
           m=mobs+mmis
           sum2=sum2+table2(m)
           if(prior(m).ne.dfloat(-999)) then
              sum1=sum1+table1(m)+prior(m)
              zflag=1
           endif
1       continue
        return
        end
C************************************************************************
        subroutine sjn(p,npatt,r,sj)
C computes s_j, the number of the last missingness pattern for which
C the jth variable needs to be imputed to complete the monotone pattern
        integer p,npatt,r(npatt,p),sj(p),patt,tmp
        do 30 j=1,p
           patt=npatt+1
10         continue
           patt=patt-1
           if(patt.ge.1)then
              if(r(patt,j).eq.0)goto 10
           endif
           sj(j)=patt
30      continue
        tmp=sj(p)
        do 40 j=p-1,1,-1
           sj(j)=max0(sj(j),tmp)
           tmp=sj(j)
40      continue
        return
        end
C***********************************************************************
C***********************************************************************
	subroutine ctrsc(x,n,p,xbar,sdv,mvcode)
C Centers and scales the data matrix so that the observed data in every
C column have mean zero and variance one. If a column has zero variance
C or less than 2 observations then the data are centered (set equal 
C to zero)
	integer n,p,count
        real x(n,p),mvcode
	double precision xbar(p),sdv(p),sum1,sum2
	do 10 j=1,p
           sum1=0
           sum2=0
           count=0
           do 5 i=1,n
              if(x(i,j).ne.mvcode) then
                 count=count+1
                 sum1=sum1+x(i,j)
                 sum2=sum2+x(i,j)**2.
              endif
5	   continue
           if(count.gt.0) then
              xbar(j)=sum1/count
              sdv(j)=sqrt((sum2-(sum1**2.)/count)/count)
              do 7 i=1,n
                 if(x(i,j).ne.mvcode) x(i,j)=x(i,j)-xbar(j)
7             continue
              if(sdv(j).gt.0.) then
                 do 9 i=1,n
                    if(x(i,j).ne.mvcode) x(i,j)=x(i,j)/sdv(j)
9                continue
               else 
                 sdv(j)=1.
              endif
           else
              sdv(j)=1.
           endif
10	continue
	return
	end
C***********************************************************************
        subroutine mkpsi(p,psi)
C Generates a symmetric matrix of integers indicating the linear
C position in packed storage of the matrix elements
        integer p,psi(0:p,0:p),posn
        posn=0
        do 10 j=0,p
           posn=posn+1
           psi(j,j)=posn
           do 5 k=j+1,p
              posn=posn+1
              psi(j,k)=posn
              psi(k,j)=posn
5          continue
10      continue
        return
        end
C***********************************************************************
        subroutine swpm(q,psi,npsi,sigma,ncells,mu,p,pivot,
     /     submat,dir,what)
C Performs sweep on parameters of mixed normal-categorical model.
C Sweeps on pivot position. Sweeps only the (1:submat,1:submat) 
C submatrix. If dir=1, performs ordinary sweep. If dir=-1, performs 
C reverse sweep. Skips over any structural zero cells having
C a value in p of -999.0. If what=1, does full sweep. If what=0,
C sweeps only sigma. If what=2, sweeps only sigma and mu.
        integer q,psi(q,q),npsi,ncells,pivot,submat,dir
        integer what
        double precision sigma(npsi),mu(q,ncells),p(ncells),a,b,c
        a=sigma(psi(pivot,pivot))
        sigma(psi(pivot,pivot))=-1./a
        do 10 j=1,submat
           if(j.ne.pivot)sigma(psi(j,pivot))=sigma(psi(j,pivot))/a*dir
10      continue
        if(what.ge.1)then
        do 11 j=1,ncells
           if(p(j).ne.-999.0) mu(pivot,j)=mu(pivot,j)/a*dir
11      continue
        endif
        do 30 i=1,submat
           if(i.ne.pivot)then
              b=sigma(psi(i,pivot))
              do 20 j=i,submat
                 if(j.ne.pivot)then
                    c=sigma(psi(j,pivot))
                    sigma(psi(i,j))=sigma(psi(i,j))-a*b*c
                 endif
20            continue
              if(what.ge.1)then
              do 21 j=1,ncells
                 if(p(j).ne.-999.0)then
                    c=mu(pivot,j)
                    mu(i,j)=mu(i,j)-a*b*c
                 endif
21            continue
              endif
           endif
30      continue
        if(what.eq.1)then
        do 40 j=1,ncells
           if(p(j).ne.-999.0)then
              c=mu(pivot,j)
              p(j)=p(j)-a*c*c
           endif
40      continue
        endif
        return
        end
C***********************************************************************
        subroutine initm(q,npsi,t1,ncells,t2,t3)
C Initializes workspace
        integer q,npsi,ncells
        double precision t1(npsi),t2(q,ncells),t3(ncells)
        do 1 i=1,npsi
           t1(i)=0
1       continue
        do 3 j=1,ncells
           t3(j)=0
           do 2 i=1,q
              t2(i,j)=0
2          continue
3       continue
        return
        end
C***********************************************************************
        subroutine tobsm(q,psi,npsi,t1,ncells,t2,t3,npattz,
     /    rz,mdpzgrp,npattw,p,rw,mdpwgrp,ngrp,mobs,mobsst,
     /    nmobs,n,z,ocw,ocz)
C Tabulates the known part of the sufficient stats for all missingness
C patterns. 
        integer q,psi(q,q),npsi,ncells,npattz,rz(npattz,q)
        integer mdpwgrp(npattw),ngrp,p
        integer mdpzgrp(npattz),npattw,rw(npattw,p)
        integer mobs(ngrp),mobsst(ngrp),nmobs(ngrp),n
        integer ocz(q),ocw(p),nocz,nocw,pattz,pattw,grpno,a,b
        real z(n,q)
        double precision t1(npsi),t2(q,ncells),t3(ncells)
        call initm(q,npsi,t1,ncells,t2,t3)
        pattw=0
        grpno=0
        do 80 pattz=1,npattz
           call gtoc(q,npattz,rz,pattz,ocz,nocz,q)
           do 70 a=1,mdpzgrp(pattz)
              pattw=pattw+1
              call gtoc(p,npattw,rw,pattw,ocw,nocw,p)
              do 60 b=1,mdpwgrp(pattw)
                 grpno=grpno+1
                 if(nocw.eq.p) t3(mobs(grpno))=t3(mobs(grpno))+
     /                nmobs(grpno)
                    do 50 i=mobsst(grpno),(mobsst(grpno)+
     /                   nmobs(grpno)-1)
                       do 20 j=1,nocz
                          if(nocw.eq.p) t2(ocz(j),mobs(grpno))=
     /                         t2(ocz(j),mobs(grpno))+z(i,ocz(j))
                          do 10 k=j,nocz
                             t1(psi(ocz(j),ocz(k)))=
     /                           t1(psi(ocz(j),ocz(k)))+
     /                           z(i,ocz(j))*z(i,ocz(k))
10                        continue
20                     continue
50                  continue
60            continue
70         continue
80      continue
        return
        end
C************************************************************************
        subroutine gtoc(p,npatt,r,patt,oc,noc,last)
C Finds the column numbers of the observed variables, and stores them
C in the first noc elements of oc. Does not go beyond column=last.
        integer p,npatt,r(npatt,p),patt,oc(p),noc,last
        noc=0
        do 10 j=1,last
           if(r(patt,j).eq.1)then
              noc=noc+1
              oc(noc)=j
           endif
10      continue
        return
        end
C***********************************************************************
        subroutine stvlm(q,psi,npsi,t1,ncells,t2)
C Creates starting values mu=0 and sigma=identity.
        integer q,psi(q,q),npsi,ncells
        double precision t1(npsi),t2(q,ncells)
        do 1 i=1,npsi
           t1(i)=0
1       continue
        do 2 j=1,q
           t1(psi(j,j))=1
2       continue
        do 4 j=1,ncells
           do 3 i=1,q
              t2(i,j)=0
3          continue
4       continue
        return
        end
C***********************************************************************
        subroutine seteqm(q,npsi,ncells,sigma1,mu1,pi1,
     /       sigma2,mu2,pi2)
C sets theta2 equal to theta1
        integer q,npsi,ncells
        double precision sigma1(npsi),mu1(q,ncells),pi1(ncells)
        double precision sigma2(npsi),mu2(q,ncells),pi2(ncells)
        do 1 i=1,npsi
           sigma2(i)=sigma1(i)
1       continue
        do 3 j=1,ncells
           pi2(j)=pi1(j)
           do 2 i=1,q
              mu2(i,j)=mu1(i,j)
2          continue
3       continue
        return
        end
C***********************************************************************
        subroutine swpobsm(q,psi,npsi,ncells,sigma,mu,pii,npattz,rz,
     /       pattz,logdet,what)
C sweeps theta to condition on the observed variables in z. Updates
C determinant in det. The initial value of det should be 1.
C If what=1, does full parameter sweep. If what=0, sweeps
C only sigma.
        integer q,psi(q,q),npsi,ncells,npattz,rz(npattz,q),pattz
        integer what
        double precision sigma(npsi),mu(q,ncells),pii(ncells),logdet
        do 10 j=1,q
           if((rz(pattz,j).eq.1).and.(sigma(psi(j,j)).gt.0))then
              logdet=logdet+dlog(sigma(psi(j,j)))
              call swpm(q,psi,npsi,sigma,ncells,mu,pii,j,q,1,what)
           elseif((rz(pattz,j).eq.0).and.(sigma(psi(j,j)).lt.0))then
              call swpm(q,psi,npsi,sigma,ncells,mu,pii,j,q,-1,what)
              logdet=logdet-dlog(sigma(psi(j,j)))
           endif
10      continue
        return
        end
C***********************************************************************
        subroutine tk2log(ncells,pii)
C takes 2*log of cell probs, and sets zero cells to -999.0.
        integer ncells
        double precision pii(ncells)
        do 1 i=1,ncells
           if(pii(i).gt.0)then
              pii(i)=2.*log(pii(i))
           elseif(pii(i).eq.0)then
              pii(i)=-999.0
           endif
1       continue
        return
        end
C***********************************************************************
        subroutine estepm(q,psi,npsi,ncells,sigma,mu,pii,kn1,kn2,kn3,
     /       t1,t2,t3,npattz,rz,mcz,ocz,mdpzgrp,npattw,p,rw,mcw,
     /       mdpwgrp,ngrp,mobs,mobsst,nmobs,n,z,d,jmp,c,theta)
        integer q,psi(q,q),npsi,ncells,npattz,pattz,rz(npattz,q)
        integer mcz(q),ocz(q),nmcz,nocz,pattw,grpno,a,b,n,ngrp
        integer mdpzgrp(npattz),npattw,p,rw(npattw,p),mcw(p)
        integer nmcw,mdpwgrp(npattw),dmis,c(p),d(p),jmp(p)
        integer mobs(ngrp),mobsst(ngrp),nmobs(ngrp)
        real z(n,q)
        double precision sigma(npsi),mu(q,ncells),pii(ncells)
        double precision kn1(npsi),kn2(q,ncells),kn3(ncells)
        double precision t1(npsi),t2(q,ncells),t3(ncells)
        double precision theta(ncells),logdet
        logdet=0.0d0
        pattw=0
        grpno=0
        call seteqm(q,npsi,ncells,kn1,kn2,kn3,t1,t2,t3)
        call tk2log(ncells,pii)
        do 200 pattz=1,npattz
           call swpobsm(q,psi,npsi,ncells,sigma,mu,pii,npattz,rz,
     /          pattz,logdet,1)
           call gtmc(q,npattz,rz,pattz,mcz,nmcz,q)
           call gtoc(q,npattz,rz,pattz,ocz,nocz,q)
           do 180 a=1,mdpzgrp(pattz)
              pattw=pattw+1
              call gtmc(p,npattw,rw,pattw,mcw,nmcw,p)
              call gtdmis(p,d,mcw,nmcw,dmis)
              do 170 b=1,mdpwgrp(pattw)
                 grpno=grpno+1
                 do 150 i=mobsst(grpno),(mobsst(grpno)+nmobs(grpno)-1)
                    call gtprob(q,ncells,mu,pii,n,z,i,p,mcw,nmcw,c,
     /                   d,jmp,dmis,mobs(grpno),ocz,nocz,theta)
                    if(nmcw.eq.0)then
                       call addstat1(q,psi,npsi,ncells,sigma,mu,
     /                      theta,t1,t2,t3,n,z,i,p,mcw,nmcw,c,d,jmp,
     /                      dmis,mobs(grpno),ocz,nocz,mcz,nmcz)
                    else
                       call addstat2(q,psi,npsi,ncells,sigma,mu,
     /                      theta,t1,t2,t3,n,z,i,p,mcw,nmcw,c,d,jmp,
     /                      dmis,mobs(grpno),ocz,nocz,mcz,nmcz)
                    endif
150              continue
170           continue
180        continue
200     continue
        return
        end
C***********************************************************************
        subroutine mstepm(q,psi,npsi,ncells,t1,t2,t3,n,prior)
C converts t1, t2, t3 to ML estimates
        integer q,psi(q,q),npsi,ncells,m,n
        double precision t1(npsi),t2(q,ncells),t3(ncells),sum
	double precision prior(ncells)
        do 30 j=1,q
           do 20 k=j,q
              sum=0.0d0
              do 10 m=1,ncells
                 if(t3(m).ne.0) sum=sum+t2(j,m)*t2(k,m)/t3(m)
10            continue
              t1(psi(j,k))=(t1(psi(j,k))-sum)/dfloat(n)
20         continue
30      continue
	sum=0.0d0
        do 50 m=1,ncells
	   if(prior(m).ne.-999.0) sum=sum+t3(m)+prior(m)-1.0d0
           if(t3(m).ne.0)then
              do 40 j=1,q
                 t2(j,m)=t2(j,m)/t3(m)
40            continue
           endif
50      continue
	do 60 m=1,ncells
	   if(prior(m).ne.-999.0) t3(m)=(t3(m)+prior(m)-1.0d0)/sum
 60	continue
        return
        end
C***********************************************************************
        subroutine istepm(q,psi,npsi,ncells,sigma,mu,pii,kn1,kn2,kn3,
     /       t1,t2,t3,npattz,rz,mcz,ocz,mdpzgrp,npattw,p,rw,mcw,
     /       mdpwgrp,ngrp,mobs,mobsst,nmobs,n,z,d,jmp,c,theta,chf,w,zz)
        integer q,psi(q,q),npsi,ncells,npattz,pattz,rz(npattz,q)
        integer mcz(q),ocz(q),nmcz,nocz,pattw,grpno,a,b,n,ngrp
        integer mdpzgrp(npattz),npattw,p,rw(npattw,p),mcw(p)
        integer nmcw,mdpwgrp(npattw),dmis,c(p),d(p),jmp(p)
        integer mobs(ngrp),mobsst(ngrp),nmobs(ngrp),w(n,p)
        real z(n,q),junk
        double precision sigma(npsi),mu(q,ncells),pii(ncells)
        double precision t1(npsi),t2(q,ncells),t3(ncells)
        double precision kn1(npsi),kn2(q,ncells),kn3(ncells)
        double precision theta(ncells),logdet,chf(npsi),zz(q)
        junk=gauss()
        logdet=0.0d0
        pattw=0
        grpno=0
        call tk2log(ncells,pii)
        call seteqm(q,npsi,ncells,kn1,kn2,kn3,t1,t2,t3)
        do 200 pattz=1,npattz
           call swpobsm(q,psi,npsi,ncells,sigma,mu,pii,npattz,rz,
     /          pattz,logdet,1)
           call gtmc(q,npattz,rz,pattz,mcz,nmcz,q)
           call gtoc(q,npattz,rz,pattz,ocz,nocz,q)
           call sigexm(npsi,sigma,chf,q,psi,mcz,nmcz)
           call cholsm(npsi,chf,q,psi,mcz,nmcz)
           do 180 a=1,mdpzgrp(pattz)
              pattw=pattw+1
              call gtmc(p,npattw,rw,pattw,mcw,nmcw,p)
              call gtdmis(p,d,mcw,nmcw,dmis)
              do 170 b=1,mdpwgrp(pattw)
                 grpno=grpno+1
                 do 150 i=mobsst(grpno),(mobsst(grpno)+nmobs(grpno)-1)
                    call gtprob(q,ncells,mu,pii,n,z,i,p,mcw,nmcw,c,
     /                   d,jmp,dmis,mobs(grpno),ocz,nocz,theta)
                    call istepim(q,psi,npsi,ncells,sigma,mu,
     /                   theta,t1,t2,t3,n,z,i,p,mcw,nmcw,c,d,jmp,dmis,
     /                   mobs(grpno),ocz,nocz,mcz,nmcz,chf,zz,w)
150              continue
170           continue
180        continue
200     continue
        return
        end
C***********************************************************************
        subroutine istepim(q,psi,npsi,ncells,sigma,mu,theta,t1,t2,
     /       t3,n,z,i,p,mcw,nmcw,c,d,jmp,dmis,mobs,ocz,nocz,mcz,nmcz,
     /       chf,zz,w)
C Draws missing data for unit i and increments sufficient statistics.
        integer q,psi(q,q),npsi,ncells,n,i,p,mcw(p),nmcw,d(p)
        integer jmp(p),dmis,mobs,ocz(q),nocz,mcz(q),nmcz,mmis,m,a
        integer c(p),w(n,p)
        double precision sigma(npsi),mu(q,ncells),theta(ncells)
        double precision t1(npsi),t2(q,ncells),t3(ncells),sum
        double precision chf(npsi),u,sum1,sum2,zz(q)
        real z(n,q)
        call initc(p,c,mcw,nmcw)
        mmis=0
        u=rangen(0)
        sum1=0.0d0
        do 200 a=1,dmis
           if(a.ne.1)then
              call advc(p,c,d,mcw,nmcw)
              call gtmmis(p,c,mcw,nmcw,jmp,mmis)
           endif
           m=mobs+mmis
           if(theta(m).ne.-999.0)then
              sum1=sum1+theta(m)
              if((sum1.ge.u).or.(a.eq.dmis))then
                 if(nmcw.gt.0) t3(m)=t3(m)+1.0d0
                 do 5 j=1,nmcw
                    w(i,mcw(j))=c(mcw(j))
5                continue
                 do 20 j=1,nmcz
                    sum=mu(mcz(j),m)
                    do 10 k=1,nocz
                       sum=sum+sigma(psi(mcz(j),ocz(k)))*z(i,ocz(k))
10                  continue
                    z(i,mcz(j))=sum
20               continue
                 do 100 j=1,nmcz
                    zz(mcz(j))=gauss()
                    sum2=0.0d0
                    do 80 k=1,j
                       sum2=sum2+zz(mcz(k))*chf(psi(mcz(j),mcz(k)))
80                  continue
                    z(i,mcz(j))=z(i,mcz(j))+sum2
100              continue
                 if(nmcw.eq.0)then
                    do 105 j=1,nmcz
                       t2(mcz(j),m)=t2(mcz(j),m)+z(i,mcz(j))
 105                continue
                 else
                    do 108 j=1,q
                       t2(j,m)=t2(j,m)+z(i,j)
 108                continue
                 endif
                 do 130 j=1,nmcz
                    do 110 k=1,nocz
                       t1(psi(mcz(j),ocz(k)))=t1(psi(mcz(j),ocz(k)))
     /                   + z(i,mcz(j))*z(i,ocz(k))
 110                continue
                    do 120 k=1,j
                       t1(psi(mcz(j),mcz(k)))=t1(psi(mcz(j),mcz(k)))
     /                   + z(i,mcz(j))*z(i,mcz(k))
 120                continue
 130             continue
              goto 210
              endif
           endif
200     continue
210     continue
        return
        end
C***********************************************************************
        subroutine pstepm(q,psi,npsi,ncells,t1,t2,t3,n,p,prior,chf,
     /     mx,zz,mcz,err)
C Converts t1, t2, t3 to draws from the complete-data posterior.
C If the observed count for any non-structural zero cell is zero, the
C posterior is not proper and err is set to 1.
        integer q,psi(q,q),npsi,ncells,p,mcz(q),n,m
        real junk
        double precision t1(npsi),t2(q,ncells),t3(ncells),df
        double precision prior(ncells),zz(q),sum,mx(q,q),chf(npsi)
        junk=gauss()
        err=0
        df=dfloat(n)
        do 1 m=1,ncells
           if(prior(m).ne.-999.0)then
              if(t3(m).le.0.0d0)then
                 err=1
                 goto 200
              else
                 df=df-1.0d0
              endif
           endif
 1      continue
C calculate least-squares quantities
        do 30 j=1,q
           do 20 k=j,q
              sum=0.0d0
              do 10 m=1,ncells
                 if(prior(m).ne.-999.0)then
                    sum=sum+t2(j,m)*t2(k,m)/t3(m)
                 endif
 10           continue
              t1(psi(j,k))=t1(psi(j,k))-sum
 20        continue
 30     continue
        do 50 m=1,ncells
           if(prior(m).ne.-999.0)then
              do 40 j=1,q
                 t2(j,m)=t2(j,m)/t3(m)
 40           continue
           endif
 50     continue
C draw mu and sigma
        do 55 j=1,q
           mcz(j)=j
 55     continue
        call cholsm(npsi,t1,q,psi,mcz,q)
        call bfacm(npsi,chf,q,psi,df)
        call invtrm(npsi,chf,q,psi)
        call mmnm(npsi,chf,t1,q,psi,mx)
        do 80 m=1,ncells
           if(prior(m).ne.-999.0)then
              do 58 k=1,q
                 zz(k)=dble(gauss())
 58           continue
              do 70 i=1,q
                 sum=0.0d0
                 do 60 k=1,q
                    sum=sum+mx(k,i)*zz(k)
 60              continue
                 t2(i,m)=t2(i,m)+sum/dsqrt(t3(m))
 70           continue
           endif
 80     continue
        do 100 i=1,q
           do 90 j=i,q
              sum=0.0d0
              do 85 k=1,q
                 sum=sum+mx(k,i)*mx(k,j)
 85           continue
              t1(psi(i,j))=sum
 90        continue
 100    continue
C draw cell probs
        sum=0.0d0
        do 105 m=1,ncells
           if(prior(m).eq.-999.0)then
              t3(m)=0.0d0
           else
              df=df-1.0d0
              t3(m)=gamm(sngl(t3(m)+prior(m)))
              sum=sum+t3(m)
           endif
 105      continue
        do 108 m=1,ncells
           t3(m)=t3(m)/sum
 108    continue
 200    continue
        return
        end
C***********************************************************************
        subroutine mstepcm(q,psi,npsi,ncells,t1,t2,t3,sigma,mu,n,
     /       r,design,wk,mcr,psir,npsir,wkr,wkd,beta)
        integer q,psi(q,q),npsi,ncells,m,n,r,mcr(r),npsir
        integer psir(r,r),mi,h
        double precision t1(npsi),t2(q,ncells),t3(ncells),sum
        double precision sigma(npsi),mu(q,ncells),beta(r,q)
        double precision design(ncells,r),wk(npsir),wkr(r),wkd(ncells)
C calculate least-squares quantities
        do 30 j=1,r
           do 20 k=j,r
              sum=0.0d0
              do 10 m=1,ncells
                 sum=sum+design(m,j)*design(m,k)*t3(m)
10            continue
              wk(psir(j,k))=sum
20         continue
30      continue
        call invsym(r,psir,npsir,wk,mcr)
        do 100 h=1,r
           do 60 mi=1,ncells
              sum=0.0d0
              do 50 j=1,r
                 sum=sum+wk(psir(h,j))*design(mi,j)
50            continue
              wkd(mi)=sum
60         continue
           do 90 k=1,q
              sum=0.0d0
              do 80 mi=1,ncells
                 sum=sum+wkd(mi)*t2(k,mi)
80            continue
              beta(h,k)=sum
90         continue
100     continue
        do 150 j=1,q
           do 110 h=1,r
              sum=0.0d0
              do 105 m=1,ncells
                 sum=sum+t2(j,m)*design(m,h)
105           continue
              wkr(h)=sum
110        continue
           do 140 k=j,q
              sum=0.0d0
              do 120 h=1,r
                 sum=sum+wkr(h)*beta(h,k)
120           continue
              sigma(psi(j,k))=(t1(psi(j,k))-sum)/dfloat(n)
140        continue
150     continue
C calculate mu from beta
        do 300 m=1,ncells
           do 240 j=1,q
              sum=0.0d0
              do 235 i=1,r
                 sum=sum+design(m,i)*beta(i,j)
235           continue
              mu(j,m)=sum
240         continue
300     continue
        return
        end
C***********************************************************************
        subroutine mmnm(d,l,u,p,psi,m)
C Multiplies lower triangular matrix l by upper-triangular matrix u,
C both in packed storage, and puts result into m which is unpacked
        integer d,p,psi(p,p)
        double precision l(d),u(d),sum,m(p,p)
        do 10 i=1,p
	   do 5 j=1,p
	     sum=0
             do 2 k=1,min(i,j)
	        sum=sum+l(psi(i,k))*u(psi(k,j))
2            continue
             m(i,j)=sum
5          continue
10      continue
        return
        end
C***********************************************************************
	subroutine cholsm(d,theta,p,psi,mc,nmc)
	integer d,p,psi(p,p),mc(p),nmc
	double precision theta(d),tmp
	do 40 i=1,nmc
	  tmp=dble(0.)
	  do 10 k=1,i-1
	    tmp=tmp+theta(psi(mc(k),mc(i)))**2
10	  continue
	  theta(psi(mc(i),mc(i)))=sqrt(theta(psi(mc(i),mc(i)))-tmp)
	  do 30 j=i+1,nmc
	    tmp=0.
	    do 20 k=1,i-1
	      tmp=tmp+theta(psi(mc(k),mc(i)))*theta(psi(mc(k),mc(j)))
20	    continue
	    theta(psi(mc(i),mc(j)))=(theta(psi(mc(i),mc(j)))-tmp)
     /             /theta(psi(mc(i),mc(i)))
30	  continue
40	continue
	end
C***********************************************************************
        subroutine invtrm(npsi,t,q,psi)
C Inverts triangular matrix in packed storage
        integer npsi,q,psi(q,q)
        double precision t(npsi),sum
        t(psi(1,1))=1./t(psi(1,1))
        do 10 k=2,q
           t(psi(k,k))=dble(1.)/t(psi(k,k))
           do 5 j=1,k-1
              sum=0
              do 3 i=j,k-1
                 sum=sum+t(psi(i,j))*t(psi(i,k))
3             continue
              t(psi(j,k))=-sum*t(psi(k,k))
5          continue
10      continue
        return
        end
C***********************************************************************
        subroutine invsym(q,psi,npsi,mat,mc)
C inverts symmetric matrix in packed storage
        integer q,psi(q,q),npsi,mc(q)
        double precision mat(npsi),sum
        do 1 j=1,q
           mc(j)=j
1       continue
        call cholsm(npsi,mat,q,psi,mc,q)
        call invtrm(npsi,mat,q,psi)
        do 4 j=1,q
           do 3 k=1,j
              sum=0.0d0
              do 2 i=j,q
                 sum=sum+mat(psi(i,j))*mat(psi(i,k))
2             continue
              mat(psi(j,k))=sum
3          continue
4       continue
        return
        end
C***********************************************************************
        subroutine bfacm(npsi,b,q,psi,m)
C draws triangular square-root of a Wishart(m,I) using Bartlett
C decomposition, putting result into packed storage
        integer npsi,q,psi(q,q)
        double precision b(npsi),m
	do 10 j=1,q
	   b(psi(j,j))=dble(sqrt(2.*gamm((sngl(m)-float(j)+1.)/2.)))
10      continue
        do 30 j=1,q-1
	   do 20 k=j+1,q
             b(psi(j,k))=dble(gauss())
20         continue
30      continue
        return
        end
C***********************************************************************
        subroutine pstepcm(q,psi,npsi,ncells,t1,t2,t3,sigma,mu,n,
     /       r,design,wk,mcr,psir,npsir,wkr,wkd,mcz,chf,beta,mx)
        integer q,psi(q,q),npsi,ncells,m,r,mcr(r),npsir
        integer psir(r,r),mi,mcz(q),h
        real junk
        double precision t1(npsi),t2(q,ncells),t3(ncells),sum
        double precision sigma(npsi),mu(q,ncells)
        double precision design(ncells,r),wk(npsir),wkr(r),wkd(ncells)
        double precision chf(npsi),beta(r,q),zz,mx(q,q),df
        junk=gauss()
C calculate least-squares quantities
        do 30 j=1,r
           do 20 k=j,r
              sum=0.0d0
              do 10 m=1,ncells
                 sum=sum+design(m,j)*design(m,k)*t3(m)
 10           continue
              wk(psir(j,k))=sum
 20        continue
 30     continue
        call invsym(r,psir,npsir,wk,mcr)
        do 100 h=1,r
           do 60 mi=1,ncells
              sum=0.0d0
              do 50 j=1,r
                 sum=sum+wk(psir(h,j))*design(mi,j)
 50           continue
              wkd(mi)=sum
 60        continue
           do 90 k=1,q
              sum=0.0d0
              do 80 mi=1,ncells
                 sum=sum+wkd(mi)*t2(k,mi)
 80           continue
              beta(h,k)=sum
 90        continue
 100    continue
        do 150 j=1,q
           do 110 h=1,r
              sum=0.0d0
              do 105 m=1,ncells
                 sum=sum+t2(j,m)*design(m,h)
 105          continue
              wkr(h)=sum
 110       continue
           do 140 k=j,q
              sum=0.0d0
              do 120 h=1,r
                 sum=sum+wkr(h)*beta(h,k)
 120          continue
              t1(psi(j,k))=t1(psi(j,k))-sum
 140       continue
 150    continue
C draw sigma
        do 155 j=1,q
           mcz(j)=j
 155    continue
        df=dfloat(n-r)
        call cholsm(npsi,t1,q,psi,mcz,q)
        call bfacm(npsi,chf,q,psi,df)
        call invtrm(npsi,chf,q,psi)
        call mmnm(npsi,chf,t1,q,psi,mx)
        do 200 i=1,q
           do 190 j=i,q
              sum=0.0d0
              do 185 k=1,q
                 sum=sum+mx(k,i)*mx(k,j)
 185          continue
              sigma(psi(i,j))=sum
 190       continue
 200    continue
C draw beta      
        do 251 j=1,npsi
           chf(j)=sigma(j)
 251    continue
        call cholsm(npsi,chf,q,psi,mcz,q)
        call cholsm(npsir,wk,r,psir,mcr,r)
        do 300 j=1,q
           do 260 k=1,r
              wkr(k)=0.0d0
 260       continue
           do 270 k=1,r
              zz=gauss()
              do 265 h=k,r
                 wkr(h)=wkr(h)+zz*wk(psir(h,k))
 265          continue
 270       continue
           do 290 k=j,q
              do 280 h=1,r
                 beta(h,k)=beta(h,k)+chf(psi(j,k))*wkr(h)
 280          continue
 290       continue
 300    continue
C calculate mu from beta
        do 400 m=1,ncells
           do 340 j=1,q
              sum=0.0d0
              do 335 i=1,r
                 sum=sum+design(m,i)*beta(i,j)
 335          continue
              mu(j,m)=sum
 340       continue
 400    continue
        return
        end
C************************************************************************
        subroutine addstat1(q,psi,npsi,ncells,sigma,mu,theta,t1,t2,
     /       t3,n,z,i,p,mcw,nmcw,c,d,jmp,dmis,mobs,ocz,nocz,mcz,nmcz)
        integer q,psi(q,q),npsi,ncells,n,i,p,mcw(p),nmcw,d(p)
        integer jmp(p),dmis,mobs,ocz(q),nocz,mcz(q),nmcz,c(p)
        double precision sigma(npsi),mu(q,ncells),theta(ncells)
        double precision t1(npsi),t2(q,ncells),t3(ncells),sum
        real z(n,q)
        do 20 j=1,nmcz
           sum=mu(mcz(j),mobs)
           do 10 k=1,nocz
              sum=sum+sigma(psi(mcz(j),ocz(k)))*z(i,ocz(k))
10         continue
           z(i,mcz(j))=sum
           t2(mcz(j),mobs)=t2(mcz(j),mobs)+sum
20      continue
        do 100 j=1,nmcz
           do 70 k=1,nocz
              t1(psi(mcz(j),ocz(k)))=t1(psi(mcz(j),ocz(k)))+
     /             z(i,mcz(j))*z(i,ocz(k))
70         continue
           do 80 k=j,nmcz
              t1(psi(mcz(j),mcz(k)))=t1(psi(mcz(j),mcz(k)))+
     /             z(i,mcz(j))*z(i,mcz(k))+sigma(psi(mcz(j),mcz(k)))
80         continue
100     continue
        return
        end
C***********************************************************************
        subroutine addstat2(q,psi,npsi,ncells,sigma,mu,theta,t1,t2,
     /       t3,n,z,i,p,mcw,nmcw,c,d,jmp,dmis,mobs,ocz,nocz,mcz,nmcz)
        integer q,psi(q,q),npsi,ncells,n,i,p,mcw(p),nmcw,c(p),d(p)
        integer jmp(p),dmis,mobs,ocz(q),nocz,mcz(q),nmcz,mmis,m,a
        double precision sigma(npsi),mu(q,ncells),theta(ncells)
        double precision t1(npsi),t2(q,ncells),t3(ncells),sum
        real z(n,q)
        call initc(p,c,mcw,nmcw)
        mmis=0
        do 200 a=1,dmis
           if(a.ne.1)then
              call advc(p,c,d,mcw,nmcw)
              call gtmmis(p,c,mcw,nmcw,jmp,mmis)
           endif
           m=mobs+mmis
           if(theta(m).ne.-999.0)then
              t3(m)=t3(m)+theta(m)
              do 20 j=1,nmcz
                 sum=mu(mcz(j),m)
                 do 10 k=1,nocz
                    sum=sum+sigma(psi(mcz(j),ocz(k)))*z(i,ocz(k))
10               continue
                 z(i,mcz(j))=sum
                 t2(mcz(j),m)=t2(mcz(j),m)+sum*theta(m)
20            continue
              do 30 j=1,nocz
                 t2(ocz(j),m)=t2(ocz(j),m)+z(i,ocz(j))*theta(m)
30            continue
              do 100 j=1,nmcz
                 do 70 k=1,nocz
                    t1(psi(mcz(j),ocz(k)))=t1(psi(mcz(j),ocz(k)))+
     /                   theta(m)*z(i,mcz(j))*z(i,ocz(k))
70               continue
                 do 80 k=j,nmcz
                    t1(psi(mcz(j),mcz(k)))=t1(psi(mcz(j),mcz(k)))+
     /                   theta(m)*z(i,mcz(j))*z(i,mcz(k))+
     /                   theta(m)*sigma(psi(mcz(j),mcz(k)))
80               continue
100           continue
           endif
200     continue
        return
        end
C***********************************************************************
        subroutine gtprob(q,ncells,mu,pii,n,z,i,p,mcw,nmcw,c,d,jmp,
     /       dmis,mobs,ocz,nocz,theta)
C Calculates cell probs corresponding to observation i in z, storing 
C the result in theta. For structural zeros, theta is set to -999.0.
        integer i,q,ncells,n,p,mcw(p),nmcw,d(p),jmp(p),dmis,mobs
        integer mmis,m,a,ocz(q),nocz,c(p)
        double precision mu(q,ncells),pii(ncells),sum,theta(ncells)
        real z(n,q)
        call initc(p,c,mcw,nmcw)
        sum=0.0d0
        mmis=0
        do 30 a=1,dmis
           if(a.ne.1)then
              call advc(p,c,d,mcw,nmcw)
              call gtmmis(p,c,mcw,nmcw,jmp,mmis)
           endif
           m=mobs+mmis
           theta(m)=pii(m)
           if(theta(m).ne.-999.0)then
              theta(m)=0.5*theta(m)
              do 20 j=1,nocz
                 theta(m)=theta(m)+mu(ocz(j),m)*z(i,ocz(j))
20            continue
              theta(m)=exp(theta(m))
              sum=sum+theta(m)
           endif
30      continue
        call initc(p,c,mcw,nmcw)
        mmis=0
        do 40 a=1,dmis
           if(a.ne.1)then
              call advc(p,c,d,mcw,nmcw)
              call gtmmis(p,c,mcw,nmcw,jmp,mmis)
           endif
           m=mobs+mmis
           if(theta(m).ne.-999.0) theta(m)=theta(m)/sum
40      continue
        return
        end
C************************************************************************
        subroutine lobsm(q,psi,npsi,ncells,sigma,mu,pii,npattz,rz,mcz,
     /       ocz,mdpzgrp,npattw,p,rw,mcw,mdpwgrp,ngrp,mobs,mobsst,nmobs,
     /       n,z,d,jmp,c,ll)
        integer q,psi(q,q),npsi,ncells,npattz,pattz,rz(npattz,q)
        integer mcz(q),ocz(q),nmcz,nocz,pattw,grpno,a,b,n,ngrp
        integer mdpzgrp(npattz),npattw,p,rw(npattw,p),mcw(p)
        integer nmcw,mdpwgrp(npattw),dmis,c(p),d(p),jmp(p)
        integer mobs(ngrp),mobsst(ngrp),nmobs(ngrp)
        real z(n,q)
        double precision sigma(npsi),mu(q,ncells),pii(ncells)
        double precision ll,l2,l3,pi,logdet
        data pi/3.141592654/
        l2=0.0d0
        l3=0.0d0
        logdet=0.0d0
        pattw=0
        grpno=0
        do 200 pattz=1,npattz
           call swpobsm(q,psi,npsi,ncells,sigma,mu,pii,npattz,rz,
     /          pattz,logdet,0)
           call gtmc(q,npattz,rz,pattz,mcz,nmcz,q)
           call gtoc(q,npattz,rz,pattz,ocz,nocz,q)
           do 180 a=1,mdpzgrp(pattz)
              pattw=pattw+1
              call gtmc(p,npattw,rw,pattw,mcw,nmcw,p)
              call gtdmis(p,d,mcw,nmcw,dmis)
              do 170 b=1,mdpwgrp(pattw)
                 grpno=grpno+1
                 do 150 i=mobsst(grpno),(mobsst(grpno)+nmobs(grpno)-1)
                    call qdfrm(q,psi,npsi,ncells,sigma,mu,pii,
     /                   n,z,i,p,mcw,nmcw,c,d,jmp,dmis,
     /                   mobs(grpno),ocz,nocz,mcz,nmcz,l3)
150              continue
                 l2=l2+logdet*dfloat(nmobs(grpno))
170           continue
180        continue
200     continue
        ll=-(l2/dfloat(2))+l3
        return
        end
C************************************************************************
        subroutine qdfrm(q,psi,npsi,ncells,sigma,mu,pii,
     /       n,z,i,p,mcw,nmcw,c,d,jmp,dmis,mobs,ocz,nocz,mcz,nmcz,l3)
        integer q,psi(q,q),npsi,ncells,n,i,p,mcw(p),nmcw,d(p)
        integer jmp(p),dmis,mobs,ocz(q),nocz,mcz(q),nmcz,mmis,m,a,c(p)
        double precision sigma(npsi),mu(q,ncells),pii(ncells)
        double precision sum,l3,qf,lsum
        real z(n,q)
        lsum=0.0d0
        call initc(p,c,mcw,nmcw)
        mmis=0
        do 200 a=1,dmis
           if(a.ne.1)then
              call advc(p,c,d,mcw,nmcw)
              call gtmmis(p,c,mcw,nmcw,jmp,mmis)
           endif
           m=mobs+mmis
           if(pii(m).gt.0)then
              qf=0.0d0
              do 20 j=1,nocz
                 sum=0.0d0
                 do 10 k=1,nocz
                    sum=sum+sigma(psi(ocz(j),ocz(k)))*
     /                   (z(i,ocz(k))-mu(ocz(k),m))
10               continue
                 qf=qf+sum*(z(i,ocz(j))-mu(ocz(j),m))
20            continue
              lsum=lsum+pii(m)*exp(qf/dfloat(2))
           endif
200     continue
        l3=l3+dlog(lsum)
        return
        end
C***********************************************************************
        subroutine sigexm(d,theta,extr,p,psi,mc,nmc)
C Extracts submatrix of theta corresponding to the columns of mc
        integer d,p,psi(p,p),mc(p),nmc
        double precision theta(d),extr(d)
        do 2 j=1,nmc
           do 1 k=j,nmc
              extr(psi(mc(j),mc(k)))=theta(psi(mc(j),mc(k)))
1          continue
2       continue
        return
        end
C***********************************************************************
        function chisq(df)
C Generates a chisquare deviate with df degrees of freedom
        real df
        chisq=2.*gamm(df/2.)
        return
        end
C***********************************************************************
	function gauss()
	integer alt
	real next
        save alt,next
	data pi/3.141593/
        if((alt.ne.0).and.(alt.ne.1)) alt=0
	if(alt.eq.0)then
	  u1=rangen(0)
	  u2=rangen(0)
	  gauss=sqrt(-2*log(u1))*cos(2*pi*u2)
	  next=sqrt(-2*log(u1))*sin(2*pi*u2)
	  alt=1
	else
	  gauss=next
	  alt=0
	endif
	return
	end
C***********************************************************************
        subroutine swp(d,theta,pivot,p,psi,submat,dir)
C Performs sweep on a symmetric matrix in packed storage.
C Sweeps on pivot position. Sweeps only the (0:submat,0:submat)
C submatrix.
C If dir=1, performs ordinary sweep. If dir=-1, performs reverse sweep.
        integer d,p,pivot,psi(0:p,0:p),submat,dir
        double precision theta(d),a,b,c
        a=theta(psi(pivot,pivot))
        theta(psi(pivot,pivot))=-1./a
        do 10 j=0,submat
           if(j.ne.pivot) theta(psi(j,pivot))=theta(psi(j,pivot))/a*dir
10      continue
        do 30 i=0,submat
           do 20 j=i,submat
              if((i.ne.pivot).and.(j.ne.pivot))then
                 b=theta(psi(i,pivot))
                 c=theta(psi(j,pivot))
                 theta(psi(i,j))=theta(psi(i,j))-a*b*c
              endif
20         continue
30      continue
        return
        end
C***********************************************************************
        subroutine initn(d,theta)
C Initializes theta
        integer d
        double precision theta(d)
        theta(1)=1.
        do 1 i=2,d
           theta(i)=0.
1       continue
        return
        end
C***********************************************************************
        subroutine stvaln(d,theta,p,psi)
C Gets starting value of theta: mu=0 and sigma=I
        integer d,p,psi(0:p,0:p)
        double precision theta(d)
        call initn(d,theta)
        theta(1)=-1.
        do 5 j=1,p
           theta(psi(j,j))=1.
5       continue
        return
        end
C***********************************************************************
        subroutine tobsn(d,tobs,p,psi,n,x,npatt,r,mdpst,nmdp,oc)
C Tabulates the known part of the sscp matrix for all missingness
C patterns.
        integer d,p,psi(0:p,0:p),n,npatt,r(npatt,p),nmdp(npatt)
        integer mdpst(npatt),oc(p),noc,patt
        real x(n,p)
        double precision tobs(d)
        call initn(d,tobs)
        do 40 patt=1,npatt
           call gtoc(p,npatt,r,patt,oc,noc,p)
           do 30 i=mdpst(patt),mdpst(patt)+nmdp(patt)-1
              do 20 j=1,noc
                 tobs(psi(0,oc(j)))=tobs(psi(0,oc(j)))+x(i,oc(j))
                 do 10 k=j,noc
                    tobs(psi(oc(j),oc(k)))=tobs(psi(oc(j),oc(k)))+
     /                   x(i,oc(j))*x(i,oc(k))
10               continue
20            continue
30         continue
40      continue
        return
        end
C************************************************************************
        subroutine emn(d,theta,t,tobs,p,psi,n,x,npatt,r,mdpst,nmdp,
     /      oc,mc,c,mle,tau,m,mu,lmbinv)
C Performs one step of em. Theta must be in sweep(0) condition. 
C After execution, the new parameter value is contained in t, and
C theta is left swept on columns corresponding to observed variables
C in the first missingness pattern. 
        integer d,p,psi(0:p,0:p),n,npatt,r(npatt,p),nmdp(npatt)
        integer mdpst(npatt),oc(p),noc,mc(p),nmc,patt,mle
        real x(n,p)
        double precision theta(d),t(d),tobs(d),c(p),tau,m,mu(p)
        double precision lmbinv(p,p)
        do 1 i=1,d
           t(i)=tobs(i)
1       continue
        do 200 patt=1,npatt
           call swpobs(d,theta,p,psi,npatt,r,patt)
           call gtmc(p,npatt,r,patt,mc,nmc,p)
           call gtoc(p,npatt,r,patt,oc,noc,p)
           do 150 i=mdpst(patt),mdpst(patt)+nmdp(patt)-1
              do 50 j=1,nmc
                 c(mc(j))=theta(psi(0,mc(j)))
                 do 40 k=1,noc
                    c(mc(j))=c(mc(j))+theta(psi(oc(k),mc(j)))*x(i,oc(k))
40               continue
50            continue
              do 100 j=1,nmc
                 t(psi(0,mc(j)))=t(psi(0,mc(j)))+c(mc(j))
                 do 70 k=1,noc
                    t(psi(oc(k),mc(j)))=t(psi(oc(k),mc(j)))+
     /                   x(i,oc(k))*c(mc(j))
70               continue
                 do 80 k=j,nmc
                    t(psi(mc(k),mc(j)))=t(psi(mc(k),mc(j)))+
     /                c(mc(k))*c(mc(j))+theta(psi(mc(k),mc(j)))
80               continue
100           continue
150        continue
200     continue
        if(mle.eq.0) then
           call moden(d,t,p,psi,n,tau,m,mu,lmbinv)
        endif
        do 210 i=2,d
           t(i)=t(i)/dfloat(n)
210     continue
        call swp(d,t,0,p,psi,p,1)
        return
        end
C************************************************************************
        subroutine moden(d,t,p,psi,n,tau,m,mu,lmbinv)
C Alters the sufficient statistics to yield a posterior mode.
        integer d,p,psi(0:p,0:p),n
        double precision t(d),tau,m,mu(p),lmbinv(p,p),c,e
        do 5 j=1,p
           mu(j)=mu(j)*dfloat(n)
5       continue
        c=tau/(dfloat(n)*(tau+dfloat(n)))
        e=dfloat(n)/(dfloat(n)+m+dfloat(p)+2.)
        do 20 j=1,p
           do 10 k=j,p
              t(psi(j,k))=t(psi(j,k))+lmbinv(j,k)-(t(psi(0,j))*
     /           t(psi(0,k)))/dfloat(n)
              t(psi(j,k))=t(psi(j,k))+c*(t(psi(0,j))-mu(j))*
     /           (t(psi(0,k))-mu(k))
              t(psi(j,k))=t(psi(j,k))*e
10         continue
20      continue
        c=dfloat(n)/(tau+dfloat(n))
        e=1.-c
        do 30 j=1,p
           t(psi(0,j))=c*t(psi(0,j))+e*mu(j)
30      continue
        do 50 j=1,p
           do 40 k=j,p
              t(psi(j,k))=t(psi(j,k))+(t(psi(0,j))*
     /           t(psi(0,k)))/dfloat(n)
40         continue
50      continue
        return
        end
C************************************************************************
        subroutine lprin(d,theta,p,psi,c,tau,m,mu,lmbinv,logpri)
C Evaluates log-prior at theta
        integer d,p,psi(0:p,0:p)
        double precision theta(d),c(p),logpri,logdet,trace
        double precision tau,m,mu(p),lmbinv(p,p)
        logdet=0.0d0  
        do 5 j=1,p
           c(j)=theta(psi(0,j))-mu(j)
5       continue
        do 10 j=1,p
           logdet=logdet+log(theta(psi(j,j)))
           call swp(d,theta,j,p,psi,p,1)
10      continue
        logpri=-logdet*(m+dfloat(p)+2.)/2.
        trace=0.0d0
        do 120 j=1,p
           do 110 k=1,p
              trace=trace-theta(psi(j,k))*(lmbinv(j,k)+tau*c(j)*c(k))
110        continue
120     continue
        logpri=logpri-trace/2.
        return
        end
C************************************************************************
        subroutine lobsn(d,theta,t,p,psi,n,x,npatt,r,mdpst,nmdp,oc,
     /    c,loglik)
C Evaluates observed-data loglikelihood at theta
        integer d,p,psi(0:p,0:p),n,npatt,r(npatt,p),nmdp(npatt)
        integer mdpst(npatt),oc(p),noc,patt
        real x(n,p)
        double precision theta(d),t(d),c(p),loglik,logdet,trace
        loglik=0.0d0
        logdet=0.0d0  
        do 5 j=1,p
           c(j)=theta(psi(0,j))
5       continue
        do 200 patt=1,npatt
           call initn(d,t)
           do 10 j=1,p
              if((r(patt,j).eq.1).and.(theta(psi(j,j)).gt.0.))then
                 logdet=logdet+log(theta(psi(j,j)))
                 call swp(d,theta,j,p,psi,p,1)
              elseif((r(patt,j).eq.0).and.(theta(psi(j,j)).lt.0.))then
                 call swp(d,theta,j,p,psi,p,-1)
                 logdet=logdet-log(theta(psi(j,j)))
              endif
10         continue
           call gtoc(p,npatt,r,patt,oc,noc,p)
           do 100 i=mdpst(patt),mdpst(patt)+nmdp(patt)-1
              do 30 j=1,noc
                 t(psi(0,oc(j)))=x(i,oc(j))-c(oc(j))
30            continue
              do 50 j=1,noc
                 do 40 k=j,noc
                    t(psi(oc(j),oc(k)))=t(psi(oc(j),oc(k)))+
     /                 t(psi(0,oc(j)))*t(psi(0,oc(k)))
40               continue
50            continue
100        continue
           trace=0.0d0
           do 120 j=1,noc
              do 110 k=1,noc
                 trace=trace-(theta(psi(oc(j),oc(k)))*
     /              t(psi(oc(j),oc(k))))
110           continue
120        continue
           loglik=loglik-(dfloat(nmdp(patt))*logdet/2.)-(trace/2.)
200     continue
        return
        end
C************************************************************************
        subroutine swpobs(d,theta,p,psi,npatt,r,patt)
C Sweeps theta to condition on the observed variables
        integer d,p,psi(0:p,0:p),npatt,r(npatt,p),patt
        double precision theta(d)
        do 10 j=1,p
           if((r(patt,j).eq.1).and.(theta(psi(j,j)).gt.0.))then
              call swp(d,theta,j,p,psi,p,1)
           elseif((r(patt,j).eq.0).and.(theta(psi(j,j)).lt.0.))then
              call swp(d,theta,j,p,psi,p,-1)
           endif
10      continue
        return
        end
C***********************************************************************
        subroutine is1n(d,theta,t,tobs,p,psi,n,x,npatt,r,mdpst,nmdp,
     /    oc,mc,z,c)
C Performs I-step of data augmentation. Randomly draws missing data Xmis
C given theta, and stores the sufficient statistics in t.
C Theta must be in sweep(0) condition. Answer is returned in
C unswept condition.
        integer d,p,psi(0:p,0:p),n,npatt,r(npatt,p),nmdp(npatt)
        integer mdpst(npatt),oc(p),noc,mc(p),nmc,patt
        real x(n,p),z(p),junk
        double precision theta(d),t(d),tobs(d),c(d)
        junk=gauss()
        do 1 i=1,d
           t(i)=tobs(i)
1       continue
        do 200 patt=npatt,1,-1
           call swpobs(d,theta,p,psi,npatt,r,patt)
           call gtmc(p,npatt,r,patt,mc,nmc,p)
           call gtoc(p,npatt,r,patt,oc,noc,p)
           call sigex(d,theta,c,p,psi,mc,nmc)
           call chols(d,c,p,psi,mc,nmc)
           do 150 i=mdpst(patt),mdpst(patt)+nmdp(patt)-1
              do 100 j=1,nmc
                 x(i,mc(j))=theta(psi(0,mc(j)))
                 do 40 k=1,noc
                    x(i,mc(j))=x(i,mc(j))+theta(psi(oc(k),
     /                 mc(j)))*x(i,oc(k))
40               continue
                 z(mc(j))=gauss()
                 do 50 k=1,j
                    x(i,mc(j))=x(i,mc(j))+z(mc(k))*c(psi(mc(j),mc(k)))
50               continue
                 t(psi(0,mc(j)))=t(psi(0,mc(j)))+x(i,mc(j))
                 do 60 k=1,noc
                    t(psi(mc(j),oc(k)))=t(psi(mc(j),oc(k)))+
     /                   x(i,mc(j))*x(i,oc(k))
60               continue
                 do 70 k=1,j
                    t(psi(mc(j),mc(k)))=t(psi(mc(j),mc(k)))+
     /                   x(i,mc(j))*x(i,mc(k))
70               continue
100           continue
150        continue
200     continue
C Divide t by n
        do 210 i=2,d
           t(i)=t(i)/dfloat(n)
210     continue
        return
        end
C***********************************************************************
        subroutine sigex(d,theta,extr,p,psi,mc,nmc)
C Extracts submatrix of theta corresponding to the columns of mc
        integer d,p,psi(0:p,0:p),mc(p),nmc
        double precision theta(d),extr(d)
        do 2 j=1,nmc
           do 1 k=j,nmc
              extr(psi(mc(j),mc(k)))=theta(psi(mc(j),mc(k)))
1          continue
2       continue
        return
        end
C***********************************************************************
	subroutine chols(d,theta,p,psi,mc,nmc)
	integer d,p,psi(0:p,0:p),mc(p),nmc
	double precision theta(d),tmp
	do 40 i=1,nmc
	  tmp=0.
	  do 10 k=1,i-1
	    tmp=tmp+theta(psi(mc(k),mc(i)))**2
10	  continue
	  theta(psi(mc(i),mc(i)))=sqrt(theta(psi(mc(i),mc(i)))-tmp)
	  do 30 j=i+1,nmc
	    tmp=0.
	    do 20 k=1,i-1
	      tmp=tmp+theta(psi(mc(k),mc(i)))*theta(psi(mc(k),mc(j)))
20	    continue
	    theta(psi(mc(i),mc(j)))=(theta(psi(mc(i),mc(j)))-tmp)
     /             /theta(psi(mc(i),mc(i)))
30	  continue
40	continue
        return
	end
C***********************************************************************
        subroutine ps1n(d,t,m,tau,theta,p,psi,n,mat,z,b,c)
C Performs P-step of data augmentation. Theta initially contains mu0 
C and lambdainverse in packed storage, and sufficient statistics are in
C t. The new parameter is written to theta. Requires workspaces 
C mat(p,p), z(p), b(d), and c(p).
        integer d,p,psi(0:p,0:p),n,c(p)
        real z(p)
        double precision m,tau,t(d),theta(d),mat(p,p),b(d)
        call swp(d,t,0,p,psi,p,1)
        do 20 j=1,p
           do 10 k=j,p
              theta(psi(j,k))=theta(psi(j,k))+dfloat(n)*t(psi(j,k))
     /     + tau*dfloat(n)/(tau+dfloat(n))*
     /     (t(psi(0,j))-theta(psi(0,j)))*(t(psi(0,k))-theta(psi(0,k)))
10         continue
20      continue
        do 30 j=1,p
           theta(psi(0,j))=dfloat(n)*t(psi(0,j))/(dfloat(n)+tau)
     /     + tau*theta(psi(0,j))/(dfloat(n)+tau)
30      continue
        tau=tau+dfloat(n)
        m=m+dfloat(n)
        call ninvwn(d,theta,tau,m,p,psi,mat,z,b,c)
        return
        end
C***********************************************************************
        subroutine invtrn(d,t,p,psi)
C Inverts triangular matrix in packed storage
        integer d,p,psi(0:p,0:p)
        double precision t(d),sum
        t(psi(1,1))=1./t(psi(1,1))
        do 10 k=2,p
           t(psi(k,k))=1./t(psi(k,k))
           do 5 j=1,k-1
              sum=0
              do 3 i=j,k-1
                 sum=sum+t(psi(i,j))*t(psi(i,k))
3             continue
              t(psi(j,k))=-sum*t(psi(k,k))
5          continue
10      continue
        return
        end
C***********************************************************************
        subroutine bfac(d,b,p,psi,m)
C draws triangular square-root of a Wishart(m,I) using Bartlett
C decomposition, putting result into packed storage
        integer d,p,psi(0:p,0:p)
        double precision b(d),m
	do 10 j=1,p
	   b(psi(j,j))=dble(sqrt(2.*gamm((sngl(m)-float(j)+1.)/2.)))
10      continue
        do 30 j=1,p-1
	   do 20 k=j+1,p
             b(psi(j,k))=dble(gauss())
20         continue
30      continue
        return
        end
C***********************************************************************
        subroutine mmn(d,l,u,p,psi,m)
C Multiplies lower triangular matrix l by upper-triangular matrix u,
C both in packed storage, and puts result into m which is unpacked
        integer d,p,psi(0:p,0:p)
        double precision l(d),u(d),sum,m(p,p)
        do 10 i=1,p
	   do 5 j=1,p
	     sum=0
             do 2 k=1,min(i,j)
	        sum=sum+l(psi(i,k))*u(psi(k,j))
2            continue
             m(i,j)=sum
5          continue
10      continue
        return
        end
C***********************************************************************
        subroutine ninvwn(d,pars,tau,m,p,psi,mat,z,b,c)
C Draws from normal-inverted Wishart distribution with parameters 
C given by pars (contains mu0 and lambdainverse, in packed storage),
C tau, and m. Needs mat(p,p), z(p), b(d), c(p) as workspaces. 
C Overwrites pars with result.
        integer d,p,psi(0:p,0:p),c(p)
        double precision pars(d),tau,m,mat(p,p),b(d),sum
        real junk, z(p)
        junk=gauss()
        do 2 j=1,p
           c(j)=j
2       continue
        call chols(d,pars,p,psi,c,p)
        call bfac(d,b,p,psi,m)
        call invtrn(d,b,p,psi)
        call mmn(d,b,pars,p,psi,mat)
C add normal errors to mu0
        do 5 j=1,p
           z(j)=gauss()
5       continue
        do 20 j=1,p
           sum=0
           do 10 k=1,p
              sum=sum+mat(k,j)*z(k)
10         continue
           pars(psi(0,j))=pars(psi(0,j))+sum/sqrt(tau)
20      continue
C put sigma=mat^t mat into pars
        do 60 i=1,p
           do 50 j=i,p
              sum=0
              do 40 k=1,p
                 sum=sum+mat(k,i)*mat(k,j)
40            continue
              pars(psi(i,j))=sum
50         continue
60      continue
        pars(psi(0,0))=-1.
        return
        end
C***********************************************************************
        subroutine ph2thn(d,theta,p,psi)
C Converts phi to theta
        integer d,p,psi(0:p,0:p)
        double precision theta(d)
        do 1 j=1,p-1
           call swp(d,theta,j,p,psi,j,1)
1       continue
        do 2 j=1,p-1
           call swp(d,theta,j,p,psi,p,-1)
2       continue
        return
        end
C***********************************************************************
        subroutine nmons(p,npatt,r,nmdp,sj,nmon)
C Computes the number of observations in (Xobs,Xmis*) for each column
C (called N_j in Figure 6.11 of book)
        integer p,npatt,r(npatt,p),nmdp(npatt),sj(p),nmon(p),patt
        do 40 j=1,p
           nmon(j)=0
           do 20 patt=1,sj(j)
              nmon(j)=nmon(j)+nmdp(patt)
20         continue
40      continue
        return
        end
C***********************************************************************
        subroutine lasts(p,npatt,sj,last)
C Finds last variable in each missingness pattern
C to complete a monotone pattern
        integer p,npatt,sj(p),last(npatt),patt,start
        do 50 j=p,1,-1
           if(j.eq.p)then
             start=1
           else
              start=sj(j+1)+1
           endif
           do 40 patt=start,sj(j)
              last(patt)=j
40         continue
50      continue
        return
        end
C***********************************************************************
        subroutine is2n(d,theta,p,psi,n,x,npatt,r,mdpst,nmdp,sj,last,
     /    oc,mc,z,c)
C Performs I-step of monotone data augmentation. Randomly draws missing 
C data Xmis* given theta to complete the monotone pattern.
        integer d,p,psi(0:p,0:p),n,npatt,r(npatt,p),nmdp(npatt)
        integer mdpst(npatt),oc(p),noc,mc(p),nmc,patt,sj(p),last(npatt)
        real x(n,p),z(p),junk
        double precision theta(d),c(d)
        junk=gauss()
        do 200 patt=1,npatt
           call swpobs(d,theta,p,psi,npatt,r,patt)
           call gtmc(p,npatt,r,patt,mc,nmc,last(patt))
           call gtoc(p,npatt,r,patt,oc,noc,last(patt))
           call sigex(d,theta,c,p,psi,mc,nmc)
           call chols(d,c,p,psi,mc,nmc)
           do 150 i=mdpst(patt),mdpst(patt)+nmdp(patt)-1
              do 100 j=1,nmc
                 x(i,mc(j))=theta(psi(0,mc(j)))
                 do 40 k=1,noc
                    x(i,mc(j))=x(i,mc(j))+theta(psi(oc(k),
     /                 mc(j)))*x(i,oc(k))
40               continue
                 z(mc(j))=gauss()
                 do 50 k=1,j
                    x(i,mc(j))=x(i,mc(j))+z(mc(k))*c(psi(mc(j),mc(k)))
50               continue
100           continue
150        continue
200     continue
        return
        end
C***********************************************************************
        subroutine layers(p,sj,layer,nlayer)
C Finds layers for observed parts of the sufficient statistics
        integer p,sj(p),layer(p),nlayer
        nlayer=0
        do 10 j=p,1,-1
           if(j.eq.p)then
              if(sj(j).gt.0) nlayer=nlayer+1
           else
              if(sj(j).gt.sj(j+1)) nlayer=nlayer+1
           endif
           layer(j)=nlayer
10      continue
        return
        end
C***********************************************************************
        subroutine tobsmn(p,psi,n,x,npatt,r,mdpst,nmdp,last,oc,sj,
     /     layer,nlayer,d,tobs)
C Calculates known parts of the sufficient statistics for monotone
C data augmentation
        integer p,psi(0:p,0:p),d,n,npatt,r(npatt,p),mdpst(npatt),
     /     nmdp(npatt),last(npatt),oc(p),noc,layer(p),nlayer,l,patt,
     /     fpatt,lpatt,sj(p)
        real x(n,p)
        double precision tobs(nlayer,d)
        do 2 l=1,nlayer
           do 1 i=1,d
              tobs(l,i)=dble(0.)
1          continue
2       continue
        lpatt=0
        do 100 l=1,nlayer
           fpatt=lpatt+1
           j=p+1
5          continue
             j=j-1
             if(layer(j).ne.l)goto 5
           lpatt=sj(j)
           do 80 patt=fpatt,lpatt
              call gtoc(p,npatt,r,patt,oc,noc,last(patt))
              do 30 i=mdpst(patt),mdpst(patt)+nmdp(patt)-1
                 tobs(l,psi(0,0))=tobs(l,psi(0,0))+dble(1.)
                 do 20 j=1,noc
                    tobs(l,psi(0,oc(j)))=tobs(l,psi(0,oc(j)))
     /                 +x(i,oc(j))
                    do 10 k=j,noc
                       tobs(l,psi(oc(j),oc(k)))=tobs(l,psi(oc(j),
     /                    oc(k)))+x(i,oc(j))*x(i,oc(k))
10                  continue
20               continue
30            continue
80         continue
100     continue
        return
        end
C***********************************************************************
	subroutine chol2(d,theta,p,psi,last)
	integer d,p,psi(0:p,0:p),last
	double precision theta(d),tmp
	do 40 i=0,last
	  tmp=0.
	  do 10 k=0,i-1
	    tmp=tmp+theta(psi(k,i))**2
10	  continue
	  theta(psi(i,i))=sqrt(theta(psi(i,i))-tmp)
	  do 30 j=i+1,last
	    tmp=0.
	    do 20 k=0,i-1
	      tmp=tmp+theta(psi(k,i))*theta(psi(k,j))
20	    continue
	    theta(psi(i,j))=(theta(psi(i,j))-tmp)/theta(psi(i,i))
30	  continue
40	continue
        return
	end
C***********************************************************************
        subroutine ps2n(p,psi,n,x,npatt,r,mdpst,nmdp,oc,mc,nmon,
     /     sj,nlayer,d,tobs,t,c,v,theta)
C P-step of monotone data augmentation
        integer p,psi(0:p,0:p),d,n,npatt,r(npatt,p),mdpst(npatt),
     /     nmdp(npatt),oc(p),noc,mc(p),nmc,nlayer,patt,nmon(p),
     /     sj(p),lsj,l
        real x(n,p),df
        double precision tobs(nlayer,d),t(d),c(d),v(0:p),theta(d)
        do 1 i=1,d
           t(i)=dble(0.)
1       continue
        lsj=0
        l=0
        do 100 j=p,1,-1
           if(sj(j).gt.lsj) then
              l=l+1
              t(psi(0,0))=t(psi(0,0))+tobs(l,psi(0,0))
              do 10 k=1,j
                 t(psi(0,k))=t(psi(0,k))+tobs(l,psi(0,k))
                 do 5 m=k,j
                    t(psi(m,k))=t(psi(m,k))+tobs(l,psi(m,k))
5                continue
10            continue
              do 20 patt=(lsj+1),sj(j)
                 call gtmc(p,npatt,r,patt,mc,nmc,j)
                 call gtoc(p,npatt,r,patt,oc,noc,j)
                 do 18 i=mdpst(patt),mdpst(patt)+nmdp(patt)-1
                    do 15 k=1,nmc
                       t(psi(0,mc(k)))=t(psi(0,mc(k)))+x(i,mc(k))
                       do 12 m=1,noc
                          t(psi(mc(k),oc(m)))=t(psi(mc(k),oc(m)))+
     /                       x(i,mc(k))*x(i,oc(m))
12                     continue
                       do 13 m=1,k
                          t(psi(mc(k),mc(m)))=t(psi(mc(k),mc(m)))+
     /                         x(i,mc(k))*x(i,mc(m))
13                     continue
15                  continue
18               continue
20            continue
           endif
           if(sj(j).gt.lsj) then
              do 25 k=0,j-1
                 call swp(d,t,k,p,psi,j,1)
25            continue
           endif
           df=float(nmon(j)+3*(p-j)-1)
           theta(psi(j,j))=t(psi(j,j))/dble(chisq(df))
           do 30 k=0,j-1
              do 28 m=k,j-1
                 c(psi(k,m))=-theta(psi(j,j))*t(psi(k,m))
28            continue
30         continue
           call chol2(d,c,p,psi,j-1)
           do 50 k=0,j-1
              v(k)=dble(gauss())
              theta(psi(k,j))=t(psi(k,j))
              do 40 m=0,k
                 theta(psi(k,j))=theta(psi(k,j))+c(psi(m,k))*v(m)
40            continue
50         continue
           if(j.gt.1)then
              if(sj(j-1).gt.sj(j))then
                 do 60 k=0,j-1
                    call swp(d,t,k,p,psi,j-1,-1)
60               continue
              elseif(sj(j-1).eq.sj(j))then
                 call swp(d,t,j-1,p,psi,j-1,-1)
              endif
           endif
           lsj=sj(j)
100     continue
        theta(psi(0,0))=dble(-1.)
        call ph2thn(d,theta,p,psi)
        return
        end
C***********************************************************************
C***********************************************************************
C The following subroutines are used by both pan() and ecme().
C***********************************************************************
      subroutine istfin(ntot,subj,m,ist,ifin)
C creates vectors of starting and finishing positions for subjects
      integer ntot,subj(ntot),m,ist(m),ifin(m),scur
      scur=-999
      icur=0
      do 100 i=1,ntot
         if(subj(i).ne.scur) then
            icur=icur+1
            ist(icur)=i
            scur=subj(i)
         endif
 100  continue
      do 200 i=1,m-1
         ifin(i)=ist(i+1)-1
 200  continue
      ifin(m)=ntot
      return
      end
C***********************************************************************
      subroutine chfc(p,pw,s)
C overwrites s (upper tri) with cholesky factor
      integer p,pw
      double precision s(p,p),sum
      do 50 i=1,pw
         sum=dble(0.)
         do 10 k=1,i-1
            sum=sum+s(k,i)**2
 10      continue
         s(i,i)=dsqrt(s(i,i)-sum)
         do 40 j=i+1,pw
            sum=dble(0.)
            do 30 k=1,i-1
               sum=sum+s(k,i)*s(k,j)
 30         continue
            s(i,j)=(s(i,j)-sum)/s(i,i)
 40      continue
 50   continue
      return
      end
C***********************************************************************
      subroutine chl(p,pw,m,s,l)
C overwrites lth layer of s (upper tri) with cholesky factor
      integer p,pw,m,l
      double precision s(p,p,m),sum
      do 50 i=1,pw
         sum=dble(0.)
         do 10 k=1,i-1
            sum=sum+s(k,i,l)**2
 10      continue
         s(i,i,l)=dsqrt(s(i,i,l)-sum)
         do 40 j=i+1,pw
            sum=dble(0.)
            do 30 k=1,i-1
               sum=sum+s(k,i,l)*s(k,j,l)
 30         continue
            s(i,j,l)=(s(i,j,l)-sum)/s(i,i,l)
 40      continue
 50   continue
      return
      end
C***********************************************************************
      subroutine bkslv(p,pw,s)
C inverts an upper triangular matrix
      integer p,pw
      double precision s(p,p),sum
      s(1,1)=dble(1.)/s(1,1)
      do 10 k=2,pw
         s(k,k)=dble(1.)/s(k,k)
         do 5 j=1,k-1
            sum=dble(0.)
            do 3 i=j,k-1
               sum=sum+s(j,i)*s(i,k)
 3          continue
            s(j,k)=-sum*s(k,k)
 5       continue
 10   continue
      return
      end
C***********************************************************************
      subroutine mm(p,pw,wm,cm)
C calculates upper tri part of cm = wm%*%t(wm), where wm is upper tri
      integer p,pw
      double precision wm(p,p),cm(p,p),sum
      do 10 i=1,pw
         do 5 j=i,pw
            sum=dble(0.)
            do 2 k=max(i,j),pw
               sum=sum+wm(i,k)*wm(j,k)
 2          continue
            cm(i,j)=sum
 5       continue
 10   continue
      return
      end
C***********************************************************************
      subroutine bkslvl(p,pw,m,s,l)
C inverts an upper triangular matrix in layer l of s
      integer p,pw,m,l
      double precision s(p,p,m),sum
      s(1,1,l)=dble(1.)/s(1,1,l)
      do 10 k=2,pw
         s(k,k,l)=dble(1.)/s(k,k,l)
         do 5 j=1,k-1
            sum=dble(0.)
            do 3 i=j,k-1
               sum=sum+s(j,i,l)*s(i,k,l)
 3          continue
            s(j,k,l)=-sum*s(k,k,l)
 5       continue
 10   continue
      return
      end
C***********************************************************************
      subroutine mmul(p,pw,m,wm,l,cm)
C calculates upper tri part of cm = wm%*%t(wm), where wm is upper tri
C(works in layer l)
      integer p,pw,m,l
      double precision wm(p,p,m),cm(p,p),sum
      do 10 i=1,pw
         do 5 j=i,pw
            sum=dble(0.)
            do 2 k=max(i,j),pw
               sum=sum+wm(i,k,l)*wm(j,k,l)
 2          continue
            cm(i,j)=sum
 5       continue
 10   continue
      return
      end
C***********************************************************************
C The following are used only by pan().
C***********************************************************************
      subroutine prelimm(ntot,subj,m,ist,ifin,pcol,pred,q,
     /     zcol,ztz,patt,nstar,p,xcol,xtxinv,wkpp)
C Preliminary manipulations for pan. After execution, 
C     ist  = vector of starting positions for subject i, i=1,...,m
C     ifin = vector of finishing positions for subject i, i=1,...,m
C     ztz  = t(z_i)%*%z, i=1,...,m
C     nstar = total number of rows in y containing data
C     xtxinv = inv( sum of t(X_i)%*%X_i )
      integer ntot,subj(ntot),m,ist(m),ifin(m),pcol,
     /     q,zcol(q),nstar,s,patt(ntot),p,xcol(p)
      double precision pred(ntot,pcol),ztz(q,q,m),sum,xtxinv(p,p),
     /     wkpp(p,p)
      call istfin(ntot,subj,m,ist,ifin)
      nstar=0
      do 10 i=1,ntot
         if(patt(i).ne.0) nstar=nstar+1
 10   continue
      do 100 s=1,m
         do 90 i=1,q
            do 80 j=i,q
               sum=dble(0.)
               do 60 k=ist(s),ifin(s)
                  if(patt(k).ne.0) then
                     sum=sum+pred(k,zcol(i))*pred(k,zcol(j))
                  endif
 60            continue
               ztz(i,j,s)=sum
               if(i.ne.j) ztz(j,i,s)=sum
 80         continue
 90      continue
 100  continue
      do 150 i=1,p
         do 140 j=i,p
            sum=dble(0.)
            do 130 k=1,ntot
               if(patt(k).ne.0) then
                  sum=sum+pred(k,xcol(i))*pred(k,xcol(j))
               endif
 130        continue
            wkpp(i,j)=sum
 140     continue
 150  continue
      call chfc(p,p,wkpp)
      call bkslv(p,p,wkpp)
      call mm(p,p,wkpp,xtxinv)
      do 160 i=1,p
         do 155 j=i,p
            xtxinv(j,i)=xtxinv(i,j)
 155     continue
 160  continue
      return
      end
C***********************************************************************
      subroutine mgibbsbd(ntot,subj,m,ist,ifin,pcol,pred,q,zcol,ztz,
     /     patt,nstar,r,y,p,xcol,npatt,rmat,sflag,beta,sigma,psi,b,
     /     xtxinv,wkpp,wkpr,eps,wkrqrq1,wkrqrq2,sig,wkrr1,wkrr2,iter,
     /     wkqr1,wkqr2,wkqrv,nhyp,hyp,delta,iposn,pstfin,betas,
     /     sigmas,psis,wkqq1,wkqq2)
C conventional Gibbs sampler for the block-diagonal version of pan
      integer ntot,subj(ntot),m,ist(m),ifin(m),pcol,sflag,
     /     q,zcol(q),nstar,patt(ntot),r,p,xcol(p),npatt,rmat(npatt,r),
     /     iter,nhyp,iposn(ntot),pstfin(npatt,2),it
      integer oc(100),mc(100)
      double precision pred(ntot,pcol),ztz(q,q,m),y(ntot,r),
     /     beta(p,r),sigma(r,r),psi(q,q,r),b(q,r,m),xtxinv(p,p),
     /     wkpp(p,p),wkpr(p,r),eps(ntot,r),wkrqrq1(r*q,r*q),
     /     wkrqrq2(r*q,r*q),sig(r*q,r*q,m),wkrr1(r,r),wkrr2(r,r),
     /     wkqr1(q,r),wkqr2(q,r),wkqrv(q*r),hyp(nhyp),
     /     delta(ntot,r),betas(p,r,iter),sigmas(r,r,iter),
     /     psis(q,q,r,iter),wkqq1(q,q),wkqq2(q,q)
      double precision wkr(100)
      real junk
      junk=gauss()
      call prelimm(ntot,subj,m,ist,ifin,pcol,pred,q,zcol,ztz,patt,
     /     nstar,p,xcol,xtxinv,wkpp)
      if(sflag.ne.1) then
C get starting values of parameters
         call mimpy(ntot,r,y,patt,npatt,rmat)
         call mkxty(ntot,r,y,pcol,pred,p,xcol,patt,wkpr)
         call mkbeta(p,r,xtxinv,wkpr,beta)
         call mkeps1(ntot,r,y,pcol,pred,p,xcol,beta,eps,patt)
         call mksigma(ntot,r,eps,nstar,sigma,patt)
         call mksigbd(r,q,m,psi,sigma,ztz,sig,wkrr1,wkrr2,wkrqrq1,
     /     wkrqrq2,1,nhyp,hyp,wkqq1,wkqq2)
         call mkpsi0bd(r,q,m,psi,sig,wkrqrq1)
      else
C set starting value of y to eps
         do 50 i=1,ntot
            do 40 j=1,r
               y(i,j)=eps(i,j)
 40         continue
 50      continue
      endif
      do 100 it=1,iter
         call mkeps1(ntot,r,y,pcol,pred,p,xcol,beta,eps,patt)
         call mksigbd(r,q,m,psi,sigma,ztz,sig,wkrr1,wkrr2,wkrqrq1,
     /     wkrqrq2,0,nhyp,hyp,wkqq1,wkqq2)
         call drb(r,q,m,b,wkrr2,eps,pcol,pred,zcol,wkqr1,
     /     wkqr2,ist,ifin,patt,ntot,sig,wkrqrq1,wkrqrq2,wkqrv)
         call drpsibd(r,q,m,psi,sig,wkqq1,wkqq2,wkqrv,nhyp,hyp,b)
         call mkeps2(ntot,m,r,y,pcol,pred,q,zcol,b,eps,patt,ist,ifin)
         call mkxty(ntot,r,eps,pcol,pred,p,xcol,patt,wkpr)
         call mkbeta(p,r,xtxinv,wkpr,beta)
         call mkeps1(ntot,r,eps,pcol,pred,p,xcol,beta,delta,patt)
         call drsigma(ntot,r,delta,nstar,sigma,patt,nhyp,hyp,wkrr1,
     /     wkrr2,p)
         call drbeta(r,sigma,xtxinv,p,beta,wkrr1,wkpp,wkpr)
         call mkeps1(ntot,r,eps,pcol,pred,p,xcol,beta,delta,patt)
         call dreps(100,100,oc,mc,100,wkr,ntot,iposn,npatt,pstfin,
     /     r,rmat,patt,delta,sigma,wkrr1,wkrr2)
         call mky(ntot,r,pcol,pred,delta,y,p,xcol,q,zcol,beta,m,b,
     /     ist,ifin,npatt,rmat,patt)
         call storebd(iter,it,p,r,beta,q,psi,sigma,betas,sigmas,psis)
 100  continue
      return
      end
C***********************************************************************
      subroutine mgibbs(ntot,subj,m,ist,ifin,pcol,pred,q,zcol,ztz,patt,
     /     nstar,r,y,p,xcol,npatt,rmat,sflag,beta,sigma,psi,b,
     /     xtxinv,wkpp,wkpr,eps,wkrqrq1,wkrqrq2,sig,wkrr1,wkrr2,iter,
     /     wkqr1,wkqr2,wkqrv,nhyp,hyp,delta,iposn,pstfin,betas,
     /     sigmas,psis)
C conventional Gibbs sampler.
      integer ntot,subj(ntot),m,ist(m),ifin(m),pcol,sflag,
     /     q,zcol(q),nstar,patt(ntot),r,p,xcol(p),npatt,rmat(npatt,r),
     /     iter,nhyp,iposn(ntot),pstfin(npatt,2),it
      integer oc(100),mc(100)
      double precision pred(ntot,pcol),ztz(q,q,m),y(ntot,r),
     /     beta(p,r),sigma(r,r),psi(r*q,r*q),b(q,r,m),xtxinv(p,p),
     /     wkpp(p,p),wkpr(p,r),eps(ntot,r),wkrqrq1(r*q,r*q),
     /     wkrqrq2(r*q,r*q),sig(r*q,r*q,m),wkrr1(r,r),wkrr2(r,r),
     /     wkqr1(q,r),wkqr2(q,r),wkqrv(q*r),hyp(nhyp),
     /     delta(ntot,r),betas(p,r,iter),sigmas(r,r,iter),
     /     psis(r*q,r*q,iter)
      double precision wkr(100)
      real junk
      junk=gauss()
      call prelimm(ntot,subj,m,ist,ifin,pcol,pred,q,zcol,ztz,patt,
     /     nstar,p,xcol,xtxinv,wkpp)
      if(sflag.ne.1) then
C get starting values of parameters
         call mimpy(ntot,r,y,patt,npatt,rmat)
         call mkxty(ntot,r,y,pcol,pred,p,xcol,patt,wkpr)
         call mkbeta(p,r,xtxinv,wkpr,beta)
         call mkeps1(ntot,r,y,pcol,pred,p,xcol,beta,eps,patt)
         call mksigma(ntot,r,eps,nstar,sigma,patt)
         call mksig(r,q,m,psi,sigma,ztz,sig,wkrr1,wkrr2,wkrqrq1,
     /     wkrqrq2,1,nhyp,hyp)
         call mkpsi0(r,q,m,psi,sig,wkrqrq1)
      else
C set starting value of y to eps
         do 50 i=1,ntot
            do 40 j=1,r
               y(i,j)=eps(i,j)
 40         continue
 50      continue
      endif
      do 100 it=1,iter
         call mkeps1(ntot,r,y,pcol,pred,p,xcol,beta,eps,patt)
         call mksig(r,q,m,psi,sigma,ztz,sig,wkrr1,wkrr2,wkrqrq1,
     /     wkrqrq2,0,nhyp,hyp)
         call drb(r,q,m,b,wkrr2,eps,pcol,pred,zcol,wkqr1,
     /     wkqr2,ist,ifin,patt,ntot,sig,wkrqrq1,wkrqrq2,wkqrv)
         call drpsi(r,q,m,psi,sig,wkrqrq1,wkrqrq2,wkqrv,nhyp,hyp,b)
         call mkeps2(ntot,m,r,y,pcol,pred,q,zcol,b,eps,patt,ist,ifin)
         call mkxty(ntot,r,eps,pcol,pred,p,xcol,patt,wkpr)
         call mkbeta(p,r,xtxinv,wkpr,beta)
         call mkeps1(ntot,r,eps,pcol,pred,p,xcol,beta,delta,patt)
         call drsigma(ntot,r,delta,nstar,sigma,patt,nhyp,hyp,wkrr1,
     /     wkrr2,p)
         call drbeta(r,sigma,xtxinv,p,beta,wkrr1,wkpp,wkpr)
         call mkeps1(ntot,r,eps,pcol,pred,p,xcol,beta,delta,patt)
         call dreps(100,100,oc,mc,100,wkr,ntot,iposn,npatt,pstfin,
     /     r,rmat,patt,delta,sigma,wkrr1,wkrr2)
         call mky(ntot,r,pcol,pred,delta,y,p,xcol,q,zcol,beta,m,b,
     /     ist,ifin,npatt,rmat,patt)
         call store(iter,it,p,r,beta,q,psi,sigma,betas,sigmas,psis)
 100  continue
      return
      end
C***********************************************************************
      subroutine storebd(iter,it,p,r,beta,q,psi,sigma,betas,sigmas,psis)
      integer iter,it,p,r,q
      double precision beta(p,r),betas(p,r,iter),sigma(r,r),
     /     sigmas(r,r,iter),psi(q,q,r),psis(q,q,r,iter)
      do 10 j=1,r
         do 5 i=1,p
            betas(i,j,it)=beta(i,j)
 5       continue
 10   continue
      do 21 l=1,r
         do 20 j=1,q
            do 15 i=1,q
               psis(i,j,l,it)=psi(i,j,l)
 15         continue
 20      continue
 21   continue
      do 30 j=1,r
         do 25 i=1,r
            sigmas(i,j,it)=sigma(i,j)
 25      continue
 30   continue
      return
      end
C***********************************************************************
      subroutine store(iter,it,p,r,beta,q,psi,sigma,betas,sigmas,psis)
      integer iter,it,p,r,q
      double precision beta(p,r),betas(p,r,iter),sigma(r,r),
     /     sigmas(r,r,iter),psi(r*q,r*q),psis(r*q,r*q,iter)
      do 10 j=1,r
         do 5 i=1,p
            betas(i,j,it)=beta(i,j)
 5       continue
 10   continue
      do 20 j=1,r*q
         do 15 i=1,r*q
            psis(i,j,it)=psi(i,j)
 15      continue
 20   continue
      do 30 j=1,r
         do 25 i=1,r
            sigmas(i,j,it)=sigma(i,j)
 25      continue
 30   continue
      return
      end
C***********************************************************************
      subroutine mky(ntot,r,pcol,pred,delta,y,p,xcol,q,zcol,beta,m,b,
     /     ist,ifin,npatt,rmat,patt)
C calculates y = delta + X%*%beta  + Z%*%b for missing observations
      integer ntot,r,pcol,p,xcol(p),q,zcol(q),m,ist(m),ifin(m),npatt,
     /     rmat(npatt,r),patt(ntot),s,st,fin
      double precision pred(ntot,pcol),delta(ntot,r),y(ntot,r),
     /     beta(p,r),b(q,r,m),sum
      do 100 s=1,m
         st=ist(s)
         fin=ifin(s)
         do 90 i=st,fin
            if(patt(i).eq.0) then
               do 20 j=1,r
                  sum=dble(0.)
                  do 10 k=1,p
                     sum=sum+pred(i,xcol(k))*beta(k,j)
 10               continue
                  do 15 k=1,q
                     sum=sum+pred(i,zcol(k))*b(k,j,s)
 15               continue
                  y(i,j)=sum+delta(i,j)
 20            continue
            else
               do 85 j=1,r
                  if(rmat(patt(i),j).eq.0) then
                     sum=dble(0.)
                     do 40 k=1,p
                        sum=sum+pred(i,xcol(k))*beta(k,j)
 40                  continue
                     do 50 k=1,q
                        sum=sum+pred(i,zcol(k))*b(k,j,s)
 50                  continue
                     y(i,j)=sum+delta(i,j)
                  endif
 85            continue
            endif
 90      continue
 100  continue
      return
      end
C***********************************************************************
      subroutine dreps(loc,lmc,oc,mc,lwkr,wkr,ntot,iposn,npatt,pstfin,
     /     r,rmat,patt,delta,sigma,wkrr1,wkrr2)
C draws residuals given parameters and random effects
      integer loc,lmc,oc(loc),mc(lmc),lwkr,nmc,noc,ntot,iposn(ntot),
     /     npatt,pstfin(npatt,2),r,rmat(npatt,r),patt(ntot),pt
      double precision wkr(lwkr),delta(ntot,r),sigma(r,r),wkrr1(r,r),
     /     wkrr2(r,r),sum
C take care of completely missing cases
      if(pstfin(1,1).ne.1) then
         do 5 i=1,r
            do 4 j=i,r
               wkrr1(i,j)=sigma(i,j)
 4          continue
 5       continue
         call chfc(r,r,wkrr1)
         do 100 i=1,(pstfin(1,1)-1)
            do 10 j=1,r
               wkr(j)=dble(gauss())
 10         continue
            do 50 j=r,1,-1
               sum=dble(0.)
               do 40 k=1,j
                  sum=sum+wkrr1(k,j)*wkr(k)
 40            continue
               wkr(j)=sum
 50         continue
            do 70 j=1,r
               delta(iposn(i),j)=wkr(j)
 70         continue
 100     continue
      endif
C now take care of partially observed cases
      do 110 i=1,r
         do 105 j=i,r
            wkrr1(i,j)=sigma(i,j)
 105     continue
 110  continue
      do 500 pt=1,npatt
         call swpobs(r,wkrr1,npatt,rmat,pt)
         do 120 i=1,r
            do 119 j=i+1,r
               wkrr1(j,i)=wkrr1(i,j)
 119        continue
 120     continue
         call getmc(r,npatt,rmat,pt,lmc,mc,nmc)
         call getoc(r,npatt,rmat,pt,loc,oc,noc)
         call chsub(r,wkrr1,lmc,mc,nmc,wkrr2)
         do 450 i=pstfin(pt,1),pstfin(pt,2)
            do 150 j=1,nmc
               wkr(j)=dble(gauss())
 150        continue
            do 200 j=nmc,1,-1
               sum=dble(0.)
               do 190 k=1,j
                  sum=sum+wkrr2(k,j)*wkr(k)
 190           continue
               wkr(j)=sum
 200        continue
            do 300 j=1,nmc
               sum=dble(0.)
               do 210 k=1,noc
                  sum=sum+wkrr1(oc(k),mc(j))*delta(iposn(i),oc(k))
 210           continue
               delta(iposn(i),mc(j))=sum+wkr(j)
 300        continue
 450     continue
 500  continue
      return
      end
C***********************************************************************
      subroutine chsub(r,sigma,lmc,mc,nmc,wkrr)
C takes cholesky factor of submatrix of sigma corresponding to mc,
C storing it in the upper-left (nmc x nmc) corner of wkrr
      integer r,lmc,mc(lmc),nmc
      double precision sigma(r,r),wkrr(r,r)
      do 10 i=1,nmc
         do 5 j=i,nmc
            wkrr(i,j)=sigma(mc(i),mc(j))
 5       continue
 10   continue
      call chfc(r,nmc,wkrr)
      return
      end
C***********************************************************************
      subroutine getmc(r,npatt,rmat,pt,lmc,mc,nmc)
      integer r,npatt,rmat(npatt,r),pt,lmc,mc(lmc),nmc,posn
      nmc=0
      posn=0
      do 10 j=1,r
         if(rmat(pt,j).eq.0) then
            nmc=nmc+1
            posn=posn+1
            mc(posn)=j
         endif
 10   continue
      return
      end
C***********************************************************************
      subroutine getoc(r,npatt,rmat,pt,loc,oc,noc)
      integer r,npatt,rmat(npatt,r),pt,loc,oc(loc),noc,posn
      noc=0
      posn=0
      do 10 j=1,r
         if(rmat(pt,j).eq.1) then
            noc=noc+1
            posn=posn+1
            oc(posn)=j
         endif
 10   continue
      return
      end
C***********************************************************************
      subroutine rsw(n,mat,p)
C reverse-sweep upper-triangular portion of mat on position p
      integer n,p
      double precision mat(n,n)
      mat(p,p)=-dble(1.)/mat(p,p)
      do 1 i=1,p-1
         mat(i,p)=mat(i,p)*mat(p,p)
 1    continue
      do 2 j=p+1,n
         mat(p,j)=mat(p,j)*mat(p,p)
 2    continue
      do 6 i=1,p-1
         do 4 j=i,p-1
            mat(i,j)=mat(i,j)+mat(i,p)*mat(j,p)/mat(p,p)
 4       continue
         do 5 j=p+1,n
            mat(i,j)=mat(i,j)+mat(i,p)*mat(p,j)/mat(p,p)
 5       continue
 6    continue
      do 8 i=p+1,n
         do 7 j=i,n
            mat(i,j)=mat(i,j)+mat(p,i)*mat(p,j)/mat(p,p)
 7       continue
 8    continue
      return
      end
C***********************************************************************
      subroutine drbeta(r,sigma,xtxinv,p,beta,wkrr1,wkpp,wkpr)
C draws adds normal(0, sigma Otimes xtxinv) noise to beta
      integer r,p
      double precision sigma(r,r),xtxinv(p,p),beta(p,r),wkrr1(r,r),
     /     wkpp(p,p),wkpr(p,r),sum
      do 2 i=1,r
         do 1 j=i,r
            wkrr1(i,j)=sigma(i,j)
 1       continue
 2    continue
      do 5 i=1,p
         do 4 j=i,p
            wkpp(i,j)=xtxinv(i,j)
 4       continue
 5    continue
      call chfc(r,r,wkrr1)
      call chfc(p,p,wkpp)
      do 10 i=1,p
         do 9 j=1,r
            wkpr(i,j)=dble(gauss())
 9       continue
 10   continue
C multiply each column of wkpr by t(wkpp)
      do 100 j=1,r
         do 80 i=p,1,-1
            sum=dble(0.)
            do 70 k=1,i
               sum=sum+wkpp(k,i)*wkpr(k,j)
 70         continue
            wkpr(i,j)=sum
 80      continue
 100  continue
C add noise
      do 200 j=1,r
         do 180 i=1,j
            do 170 k=1,p
               beta(k,j)=beta(k,j)+wkrr1(i,j)*wkpr(k,i)
 170        continue
 180     continue
 200  continue
      return
      end
C***********************************************************************
      subroutine drsigma(ntot,r,delta,nstar,sigma,patt,nhyp,hyp,wkrr1,
     /     wkrr2,p)
C draws sigma
      integer ntot,r,patt(ntot),nstar,nhyp,p
      double precision delta(ntot,r),sigma(r,r),hyp(nhyp),a,
     /     wkrr1(r,r),wkrr2(r,r)
C initialize wkrr1 to Binv
      k=1
      a=hyp(k)
      do 5 i=1,r
         do 4 j=i,r
            k=k+1
            wkrr1(i,j)=hyp(k)
 4       continue
 5    continue
C accumulate sum_i t(delta_i)%*%delta_i
      do 100 i=1,ntot
         if(patt(i).ne.0) then
            do 80 j=1,r
               do 70 k=j,r
                  wkrr1(j,k)=wkrr1(j,k)+delta(i,j)*delta(i,k)
 70            continue
 80         continue
         endif
 100  continue
C draw inverse Wishart
      call chfc(r,r,wkrr1)
      call bfac(r,sngl(a)+float(nstar-p),sigma)
      call bkslv(r,r,sigma)
      do 200 i=1,r
         do 190 j=1,r
            sum=dble(0.)
            do 180 k=1,min(i,j)
               sum=sum+wkrr1(k,i)*sigma(k,j)
 180        continue
            wkrr2(i,j)=sum
 190     continue
 200  continue
      do 300 i=1,r
         do 280 j=i,r
            sum=dble(0.)
            do 250 k=1,r
               sum=sum+wkrr2(i,k)*wkrr2(j,k)
 250        continue
            sigma(i,j)=sum
            if(i.ne.j) sigma(j,i)=sigma(i,j)
 280        continue
 300     continue
      return
      end
C***********************************************************************
      subroutine mkeps2(ntot,m,r,y,pcol,pred,q,zcol,b,eps,patt,ist,ifin)
C calculates eps = y - Z%*% b
      integer ntot,r,patt(ntot),pcol,q,zcol(q),ist(m),ifin(m),s,
     /     st,fin,m
      double precision y(ntot,r),pred(ntot,pcol),b(q,r,m),eps(ntot,r),
     /     sum
      do 100 s=1,m
         st=ist(s)
         fin=ifin(s)
         do 90 i=st,fin
            if(patt(i).ne.0) then
            do 80 j=1,r
               sum=dble(0.)
               do 70 k=1,q
                  sum=sum+pred(i,zcol(k))*b(k,j,s)
 70            continue
               eps(i,j)=y(i,j)-sum   
 80            continue
            endif
 90      continue
 100  continue
      return
      end
C***********************************************************************
      subroutine drpsibd(r,q,m,psi,sig,wkqq1,wkqq2,wkqrv,nhyp,hyp,b)
C Version of drpsi for block-diagonal pan
      integer r,q,m,s,nhyp
      double precision psi(q,q,r),sig(r*q,r*q,m),wkqq1(q,q),
     /     hyp(nhyp),wkqrv(q*r),c,b(q,r,m),sum,wkqq2(q,q)
      do 400 l=1,r
C initialize wkqq1 to appropriate portion of Dinv
         k=1 + r*(r+1)/2 + l
         c=hyp(k)
         k=1 + r*(r+1)/2 + r + (l-1)*q*(q+1)/2
         do 5 i=1,q
            do 4 j=i,q
               k=k+1
               wkqq1(i,j)=hyp(k)
 4          continue
 5       continue
C accumulate BtB into wkrr1
         do 100 s=1,m
            do 15 i=1,q
               wkqrv(i)=b(i,l,s)
 15         continue
            do 40 i=1,q
               do 30 j=i,q
                  wkqq1(i,j)=wkqq1(i,j)+wkqrv(i)*wkqrv(j)
 30            continue
 40         continue
 100     continue
C draw inverse Wishart
         call chfc(q,q,wkqq1)
         call bfac(q,sngl(c)+float(m),wkqq2)
         call bkslv(q,q,wkqq2)
         do 200 i=1,q
            do 190 j=1,q
               sum=dble(0.)
               do 180 k=1,min(i,j)
                  sum=sum+wkqq1(k,i)*wkqq2(k,j)
 180           continue
               psi(i,j,l)=sum
 190        continue
 200     continue
         do 205 i=1,q
            do 204 j=1,q
               wkqq2(i,j)=psi(i,j,l)
 204        continue
 205     continue
         do 300 i=1,q
            do 280 j=i,q
               sum=dble(0.)
               do 250 k=1,q
                  sum=sum+wkqq2(i,k)*wkqq2(j,k)
 250           continue
               psi(i,j,l)=sum
               if(i.ne.j) psi(j,i,l)=psi(i,j,l)
 280        continue
 300     continue
 400  continue
      return
      end
C***********************************************************************
      subroutine drpsi(r,q,m,psi,sig,wkrqrq1,wkrqrq2,wkqrv,nhyp,hyp,b)
C draws new value of psi
      integer r,q,m,s,nhyp
      double precision psi(r*q,r*q),sig(r*q,r*q,m),wkrqrq1(r*q,r*q),
     /     hyp(nhyp),wkqrv(q*r),c,b(q,r,m),sum,wkrqrq2(r*q,r*q)
C initialize wkrqrq1 to Dinv
      k=r*(r+1)/2 + 2
      c=hyp(k)
      do 5 i=1,r*q
         do 4 j=i,r*q
            k=k+1
            wkrqrq1(i,j)=hyp(k)
 4       continue
 5    continue
C put vec(b_i) into wkqrv
      do 100 s=1,m
         ia=0
         do 20 j=1,r
            do 15 i=1,q
               ia=ia+1
               wkqrv(ia)=b(i,j,s)
 15         continue
 20      continue
         do 40 i=1,r*q
            do 30 j=i,r*q
               wkrqrq1(i,j)=wkrqrq1(i,j)+wkqrv(i)*wkqrv(j)
 30         continue
 40      continue
 100  continue
C draw inverse Wishart
      call chfc(r*q,r*q,wkrqrq1)
      call bfac(r*q,sngl(c)+float(m),psi)
      call bkslv(r*q,r*q,psi)
      do 200 i=1,r*q
         do 190 j=1,r*q
            sum=dble(0.)
            do 180 k=1,min(i,j)
               sum=sum+wkrqrq1(k,i)*psi(k,j)
 180        continue
            wkrqrq2(i,j)=sum
 190     continue
 200  continue
      do 300 i=1,r*q
         do 280 j=i,r*q
            sum=dble(0.)
            do 250 k=1,r*q
               sum=sum+wkrqrq2(i,k)*wkrqrq2(j,k)
 250        continue
            psi(i,j)=sum
            if(i.ne.j) psi(j,i)=psi(i,j)
 280        continue
 300     continue
      return
      end
C***********************************************************************
      subroutine drb(r,q,m,b,sigmainv,eps,pcol,pred,zcol,wkqr1,
     /     wkqr2,ist,ifin,patt,ntot,sig,wkrqrq1,wkrqrq2,wkqrv)
C draws b_i, i=1,...,m. 
      integer r,q,m,s,pcol,zcol(q),ist(m),ifin(m),st,fin,patt(ntot),
     /     ntot
      double precision sig(r*q,r*q,m),eps(ntot,r),pred(ntot,pcol),
     /     sigmainv(r,r),b(q,r,m),wkqr1(q,r),wkqr2(q,r),
     /     wkrqrq1(r*q,r*q),wkrqrq2(r*q,r*q),sum,wkqrv(q*r)
      do 500 s=1,m
         st=ist(s)
         fin=ifin(s)
C put t(Z_i)%*%(jth column of eps_i) into jth column of wkqr1, j=1..r
         do 100 j=1,r
            do 90 i=1,q
               sum=dble(0.)
               do 80 k=st,fin
                  if(patt(k).ne.0) sum=sum+pred(k,zcol(i))*eps(k,j)
 80            continue
               wkqr1(i,j)=sum
 90         continue
 100     continue
C put sum_k=1^r sigmainv(j,k) *t(Z_i)%*% (col k of eps_i) into wkqr2
         do 200 j=1,r
            do 190 i=1,q
               sum=dble(0.)
               do 180 k=1,r
                  sum=sum+sigmainv(j,k)*wkqr1(i,k)
 180           continue
               wkqr2(i,j)=sum
 190        continue
 200     continue
C put sig_i into wkrqrq2 and calculate b_i
         call mmul(r*q,r*q,m,sig,s,wkrqrq2)
         do 220 i=1,r*q
            do 210 j=i+1,r*q
               wkrqrq2(j,i)=wkrqrq2(i,j)
 210        continue
 220     continue
         ia=0
         do 400 i=1,r
            do 380 ii=1,q
               ia=ia+1
               ja=0
               sum=dble(0.)
               do 370 j=1,r
                  do 360 jj=1,q
                     ja=ja+1
                     sum=sum+wkrqrq2(ia,ja)*wkqr2(jj,j)
 360              continue
 370           continue
               b(ii,i,s)=sum
 380        continue
 400     continue
         do 410 i=1,r*q
            wkqrv(i)=dble(gauss())
 410     continue
         ia=0
         do 450 i=1,r
            do 440 ii=1,q
               ia=ia+1
               sum=dble(0.)
               do 430 ja=ia,r*q
                  sum=sum+sig(ia,ja,s)*wkqrv(ja)
 430           continue
               b(ii,i,s)=b(ii,i,s)+sum
 440        continue
 450     continue
 500  continue
      return
      end
C***********************************************************************
      subroutine mkpsi0bd(r,q,m,psi,sig,wkrqrq1)
C calculates initial estimate of psi given sig.
      integer r,q,m,s
      double precision psi(q,q,r),sig(r*q,r*q,m),wkrqrq1(r*q,r*q)
      do 6 l=1,r
         do 5 i=1,q
            do 4 j=i,q
               psi(i,j,l)=dble(0.)
 4          continue
 5       continue
 6    continue
      do 100 s=1,m
         call mmul(r*q,r*q,m,sig,s,wkrqrq1)
         do 30 l=1,r
            do 20 i=1,q
               do 10 j=i,q
                  ii=(l-1)*q + i
                  jj=(l-1)*q + j
                  psi(i,j,l)=psi(i,j,l)+wkrqrq1(ii,jj)
 10            continue
 20         continue
 30      continue
 100  continue
      do 120 l=1,r
         do 110 i=1,q
            do 105 j=i,q
               psi(i,j,l)=psi(i,j,l)/dfloat(m)
               if(i.ne.j) psi(j,i,l)=psi(i,j,l)
 105        continue
 110     continue
 120  continue
      return
      end
C***********************************************************************
      subroutine mkpsi0(r,q,m,psi,sig,wkrqrq1)
C calculates initial estimate of psi given sig.
      integer r,q,m,s
      double precision psi(r*q,r*q),sig(r*q,r*q,m),wkrqrq1(r*q,r*q)
      do 5 i=1,r*q
         do 4 j=i,r*q
            psi(i,j)=dble(0.)
 4       continue
 5    continue
      do 100 s=1,m
         call mmul(r*q,r*q,m,sig,s,wkrqrq1)
         do 20 i=1,r*q
            do 10 j=i,r*q
               psi(i,j)=psi(i,j)+wkrqrq1(i,j)
 10         continue
 20      continue
 100  continue
      do 110 i=1,r*q
         do 105 j=i,r*q
            psi(i,j)=psi(i,j)/dfloat(m)
            if(i.ne.j) psi(j,i)=psi(i,j)
 105     continue
 110  continue
      return
      end
C***********************************************************************
      subroutine mksigbd(r,q,m,psi,sigma,ztz,sig,wkrr1,wkrr2,wkrqrq1,
     /     wkrqrq2,zflag,nhyp,hyp,wkqq1,wkqq2)
C Version of mksig for the block-diagonal pan.
C calculates the square root of
C       sig = inv( inv(psi) + ( inv(sigma) Otimes ztz ) ), i=1,..m
C Use zflag = 1 to set psi equal to its prior guess.
C When finished, wkrr2 contains inv(sigma).
      integer r,q,m,s,zflag,nhyp
      double precision psi(q,q,r),sigma(r,r),ztz(q,q,m),
     /     sig(r*q,r*q,m),wkrr1(r,r),wkrr2(r,r),wkrqrq1(r*q,r*q),
     /     wkrqrq2(r*q,r*q),hyp(nhyp),c,wkqq1(q,q),wkqq2(q,q)
      if(zflag.eq.1) then
         k1= 1 + r*(r+1)/2
         k2= 1 + r*(r+1)/2 + r
         do 5 l=1,r
            k1=k1+1
            c=hyp(k1)
            do 4 i=1,q
               do 3 j=i,q
                  k2=k2+1
                  psi(i,j,l)=hyp(k2)/c
 3             continue
 4          continue
 5       continue
      endif
C invert psi and put into wkrqrq2, using the fact that it's block-diagonal
      do 102 i=1,r*q
         do 101 j=i,r*q
            wkrqrq2(i,j)=dble(0.)
 101     continue
 102  continue
      do 110 l=1,r
         do 105 i=1,q
            do 104 j=i,q
               wkqq1(i,j)=psi(i,j,l)
 104        continue
 105     continue
         call chfc(q,q,wkqq1)
         call bkslv(q,q,wkqq1)
         call mm(q,q,wkqq1,wkqq2)
         do 108 i=1,q
            do 107 j=i,q
               ii=(l-1)*q + i
               jj=(l-1)*q + j
               wkrqrq2(ii,jj)=wkqq2(i,j)
 107        continue
 108     continue
 110  continue
C invert sigma and put into wkrr2
      do 7 i=1,r
         do 6 j=i,r
            wkrr1(i,j)=sigma(i,j)
 6       continue
 7    continue
      call chfc(r,r,wkrr1)
      call bkslv(r,r,wkrr1)
      call mm(r,r,wkrr1,wkrr2)
      do 9 i=1,r
         do 8 j=i+1,r
            wkrr2(j,i)=wkrr2(i,j)
 8       continue
 9    continue
      do 100 s=1,m
C initialize sig(,,s) to inv(sigma) Otimes t(Z_i)%*%Z_i
         do 30 i=1,r
            do 20 j=i,r
               do 15 ii=1,q
                  do 10 jj=1,q
                     ia=(i-1)*q+ii
                     ja=(j-1)*q+jj
                     sig(ia,ja,s)=wkrr2(i,j)*ztz(ii,jj,s)
 10               continue
 15            continue
 20         continue
 30      continue
C add in inv(psi) and take inverse square-root
         do 40 i=1,r*q
            do 35 j=i,r*q
               sig(i,j,s)=sig(i,j,s)+wkrqrq2(i,j)
 35         continue
 40      continue
         call chl(r*q,r*q,m,sig,s)
         call bkslvl(r*q,r*q,m,sig,s)
 100  continue
      return
      end
C***********************************************************************
      subroutine mksig(r,q,m,psi,sigma,ztz,sig,wkrr1,wkrr2,wkrqrq1,
     /     wkrqrq2,zflag,nhyp,hyp)
C calculates the square root of
C       sig = inv( inv(psi) + ( inv(sigma) Otimes ztz ) ), i=1,..m
C Use zflag = 1 to set psi equal to its prior guess.
C When finished, wkrr2 contains inv(sigma).
      integer r,q,m,s,zflag,nhyp
      double precision psi(r*q,r*q),sigma(r,r),ztz(q,q,m),
     /     sig(r*q,r*q,m),wkrr1(r,r),wkrr2(r,r),wkrqrq1(r*q,r*q),
     /     wkrqrq2(r*q,r*q),hyp(nhyp),c
      if(zflag.eq.1) then
         k=r*(r+1)/2 + 2
         c=hyp(k)
         do 4 i=1,r*q
            do 3 j=i,r*q
               k=k+1
               psi(i,j)=hyp(k)/c
 3          continue
 4       continue
      endif
C invert psi and put into wkrqrq2
      do 2 i=1,r*q
         do 1 j=i,r*q
            wkrqrq1(i,j)=psi(i,j)
 1       continue
 2    continue
      call chfc(r*q,r*q,wkrqrq1)
      call bkslv(r*q,r*q,wkrqrq1)
      call mm(r*q,r*q,wkrqrq1,wkrqrq2)
C invert sigma and put into wkrr2
      do 6 i=1,r
         do 5 j=i,r
            wkrr1(i,j)=sigma(i,j)
 5       continue
 6    continue
      call chfc(r,r,wkrr1)
      call bkslv(r,r,wkrr1)
      call mm(r,r,wkrr1,wkrr2)
      do 9 i=1,r
         do 8 j=i+1,r
            wkrr2(j,i)=wkrr2(i,j)
 8       continue
 9    continue
      do 100 s=1,m
C initialize sig(,,s) to inv(sigma) Otimes t(Z_i)%*%Z_i
         do 30 i=1,r
            do 20 j=i,r
               do 15 ii=1,q
                  do 10 jj=1,q
                     ia=(i-1)*q+ii
                     ja=(j-1)*q+jj
                     sig(ia,ja,s)=wkrr2(i,j)*ztz(ii,jj,s)
 10               continue
 15            continue
 20         continue
 30      continue
C add in inv(psi) and take inverse square-root
         do 40 i=1,r*q
            do 35 j=i,r*q
               sig(i,j,s)=sig(i,j,s)+wkrqrq2(i,j)
 35         continue
 40      continue
         call chl(r*q,r*q,m,sig,s)
         call bkslvl(r*q,r*q,m,sig,s)
 100  continue
      return
      end
C***********************************************************************
      subroutine mksigma(ntot,r,eps,nstar,sigma,patt)
C calculates (1/nstar)*sum of t(eps_i)%*%eps_i
      integer ntot,r,patt(ntot),nstar
      double precision eps(ntot,r),sigma(r,r)
      do 2 i=1,r
         do 1 j=i,r
            sigma(i,j)=dble(0.)
 1       continue
 2    continue
      do 100 i=1,ntot
         if(patt(i).ne.0) then
            do 90 j=1,r
               do 80 k=j,r
                  sigma(j,k)=sigma(j,k)+eps(i,j)*eps(i,k)
 80            continue
 90         continue
         endif
 100  continue
      do 110 i=1,r
         do 108 j=i,r
            sigma(i,j)=sigma(i,j)/dfloat(nstar)
            if(i.ne.j) sigma(j,i)=sigma(i,j)
 108     continue
 110  continue
      return
      end
C***********************************************************************
      subroutine mkeps1(ntot,r,y,pcol,pred,p,xcol,beta,eps,patt)
C calculates eps = y - X%*% beta
      integer ntot,r,patt(ntot),pcol,p,xcol(p)
      double precision y(ntot,r),pred(ntot,pcol),beta(p,r),eps(ntot,r),
     /     sum
      do 100 i=1,ntot
         if(patt(i).ne.0) then
            do 90 j=1,r
               sum=dble(0.)
               do 80 k=1,p
                  sum=sum+pred(i,xcol(k))*beta(k,j)
 80            continue
               eps(i,j)=y(i,j)-sum   
 90         continue
         endif
 100  continue
      continue
      return
      end
C***********************************************************************
      subroutine mkbeta(p,r,xtxinv,xty,beta)
C calculates betahat
      integer p,r
      double precision xtxinv(p,p),xty(p,r),beta(p,r),sum
      do 100 i=1,p
         do 90 j=1,r
            sum=dble(0.)
            do 50 k=1,p
               sum=sum+xtxinv(i,k)*xty(k,j)
 50         continue
            beta(i,j)=sum
 90      continue
 100  continue
      return
      end
C***********************************************************************
      subroutine mkxty(ntot,r,y,pcol,pred,p,xcol,patt,xty)
      integer ntot,r,pcol,p,xcol(p),patt(ntot)
      double precision y(ntot,r),pred(ntot,pcol),xty(p,r),sum
      do 100 i=1,p
         do 80 j=1,r
            sum=dble(0.)
            do 50 k=1,ntot
               if(patt(k).ne.0) then
                  sum=sum+pred(k,xcol(i))*y(k,j)
               endif
 50         continue
            xty(i,j)=sum
 80      continue
 100  continue
      return
      end
C***********************************************************************
      subroutine mimpy(ntot,r,y,patt,npatt,rmat)
C unconditional mean imputation for variables in y
      integer ntot,r,patt(ntot),npatt,rmat(npatt,r),denom,rij
      double precision y(ntot,r),sum,mean
      do 200 j=1,r
         sum=dble(0.)
         denom=0
         do 100 i=1,ntot
            if(patt(i).ne.0) then
               rij=rmat(patt(i),j)
               sum=sum+dfloat(rij)*y(i,j)
               denom=denom+rij
            endif
 100     continue
         mean=sum/dfloat(denom)
         do 150 i=1,ntot
            if(patt(i).ne.0) then
               if(rmat(patt(i),j).eq.0) y(i,j)=mean
            endif
 150     continue
 200  continue
      return
      end
C***********************************************************************
C The following are used only by ecme().
C***********************************************************************
      subroutine prelim(ntot,subj,m,ist,ifin,occ,nmax,vmax,vh,vi,pcol,
     /     pred,q,zcol,ztv,sig0,iflag)
C Preliminary manipulations for ECME. After execution, 
C     ist  = vector of starting positions for subject i, i=1,...,m
C     ifin = vector of finishing positions for subject i, i=1,...,m
C     vh   = inverse sqrt of V_i, i=1,...,m
C     vi   = inverse of V_i, i=1,...,m
C     ztv  = t(z_i)%*% inverse of V_i, i=1,...,m
C     sig0 = t(z_i)%*%inv(V_i)%*%(z_i), i=1,...,m
C Note: if V_i's are all identity, then let vmax, vh, vi be blank arrays
C and set iflag = 1.
      integer ntot,subj(ntot),m,ist(m),ifin(m),occ(ntot),nmax,pcol,
     /     q,zcol(q),iflag
      double precision vmax(nmax,nmax),vh(nmax,nmax,m),vi(nmax,nmax,m),
     /     pred(ntot,pcol),ztv(q,nmax,m),sig0(q,q,m)
      call istfin(ntot,subj,m,ist,ifin)
      if(iflag.ne.1) then
         call mkv(m,nmax,vmax,ntot,occ,ist,ifin,vh)
         call chv(nmax,m,vh,ntot,occ,ist,ifin)
         call bkv(nmax,m,vh,ntot,occ,ist,ifin)
         call mmulv(nmax,m,vh,vi,ntot,occ,ist,ifin)
      endif
      call mmu(ntot,pcol,pred,q,zcol,nmax,m,vh,occ,ist,ifin,ztv,iflag)
      call mmtm(q,nmax,m,ztv,ntot,occ,ist,ifin,sig0)
      if(iflag.ne.1) then
         call mml(ntot,q,nmax,m,vh,occ,ist,ifin,ztv)
      endif
      return
      end
C***********************************************************************
      subroutine stval(ntot,m,ist,ifin,occ,nmax,vi,vh,pcol,
     /     pred,q,zcol,ztv,sig0,iflag,sig,psi,sigma2,p,xcol,beta,wkq1,
     /     wkq2,wkq3,y,delta,b,wk,w,xtw,xtwx,xtwy,xtwxinv)
C Get default starting values for ECME
      integer ntot,m,ist(m),ifin(m),occ(ntot),nmax,pcol,
     /     q,zcol(q),iflag,p,xcol(p),s
      double precision vi(nmax,nmax,m),pred(ntot,pcol),
     /     ztv(q,nmax,m),sig0(q,q,m),sig(q,q,m),psi(q,q),sigma2,
     /     beta(p),wkq1(q,q),wkq2(q,q),y(ntot),delta(ntot),b(q,m),
     /     wk(q,nmax,m),vh(nmax,nmax,m),wkq3(q,q),w(nmax,nmax,m),
     /     xtw(p,nmax),xtwx(p,p),xtwy(p),xtwxinv(p,p)
      call gls(ntot,m,ist,ifin,occ,nmax,vi,vh,pcol,
     /     pred,q,zcol,ztv,sig0,iflag,sig,psi,sigma2,p,xcol,beta,wkq1,
     /     wkq2,wkq3,y,delta,b,wk,w,xtw,xtwx,xtwy,xtwxinv)
C get psi
      do 310 i=1,q
         do 305 j=i,q
            wkq1(i,j)=dble(0.)
 305     continue
 310  continue
      do 500 s=1,m
         do 400 i=1,q
            do 350 j=i,q
               wkq1(i,j)=wkq1(i,j)+sig0(i,j,s)
 350        continue
 400     continue
 500  continue
      call chfc(q,q,wkq1)
      call bkslv(q,q,wkq1)
      call mm(q,q,wkq1,psi)
      do 600 i=1,q
         do 550 j=i,q
            psi(i,j)=psi(i,j)*sigma2*dfloat(m)
            if(i.ne.j) then
               psi(j,i)=psi(i,j)
            endif
 550     continue
 600  continue
      return
      end
C***********************************************************************
      subroutine nopsi(ntot,m,ist,ifin,occ,nmax,vi,vh,pcol,
     /     pred,q,zcol,ztv,sig0,iflag,sig,psi,sigma2,p,xcol,beta,wkq1,
     /     wkq2,wkq3,y,delta,b,wk,w,xtw,xtwx,xtwy,xtwxinv,ll)
C gets GLS estimates for beta and sigma2, assuming psi=0, and evaluates
C loglikelihood
      integer ntot,m,ist(m),ifin(m),occ(ntot),nmax,pcol,
     /     q,zcol(q),iflag,p,xcol(p)
      double precision vi(nmax,nmax,m),pred(ntot,pcol),
     /     ztv(q,nmax,m),sig0(q,q,m),sig(q,q,m),psi(q,q),sigma2,
     /     beta(p),wkq1(q,q),wkq2(q,q),y(ntot),delta(ntot),b(q,m),
     /     wk(q,nmax,m),vh(nmax,nmax,m),wkq3(q,q),w(nmax,nmax,m),
     /     xtw(p,nmax),xtwx(p,p),xtwy(p),xtwxinv(p,p),ll
      call gls(ntot,m,ist,ifin,occ,nmax,vi,vh,pcol,
     /     pred,q,zcol,ztv,sig0,iflag,sig,psi,sigma2,p,xcol,beta,wkq1,
     /     wkq2,wkq3,y,delta,b,wk,w,xtw,xtwx,xtwy,xtwxinv)
      call mkll2(nmax,m,w,ntot,delta,occ,ist,ifin,ll)
      return
      end
C***********************************************************************
      subroutine mkll2(nmax,m,w,ntot,delta,occ,ist,ifin,ll)
C evaluates loglikelihood
      integer nmax,m,ntot,occ(ntot),ist(m),ifin(m),s,st,fin
      double precision w(nmax,nmax,m),delta(ntot),ll,sum
      ll=dble(0.)
      call chv(nmax,m,w,ntot,occ,ist,ifin)
      do 900 s=1,m
         st=ist(s)
         fin=ifin(s)
         sum=dble(0.)
         do 100 i=st,fin
            sum=sum+dlog(w(occ(i),occ(i),s))
 100     continue
         ll=ll+dble(2.)*sum
         do 300 i=st,fin
            sum=dble(0.)
            do 200 j=i,fin
               sum=sum+w(occ(i),occ(j),s)*delta(j)
 200        continue
            ll=ll-sum**2
 300     continue
 900  continue
      ll=ll/dble(2.)
      return
      end
C***********************************************************************
      subroutine gls(ntot,m,ist,ifin,occ,nmax,vi,vh,pcol,
     /     pred,q,zcol,ztv,sig0,iflag,sig,psi,sigma2,p,xcol,beta,wkq1,
     /     wkq2,wkq3,y,delta,b,wk,w,xtw,xtwx,xtwy,xtwxinv)
C gets GLS estimates for beta and sigma2, assuming psi=0
      integer ntot,m,ist(m),ifin(m),occ(ntot),nmax,pcol,
     /     q,zcol(q),iflag,p,xcol(p),st,fin,s
      double precision vi(nmax,nmax,m),pred(ntot,pcol),
     /     ztv(q,nmax,m),sig0(q,q,m),sig(q,q,m),psi(q,q),sigma2,
     /     beta(p),wkq1(q,q),wkq2(q,q),y(ntot),delta(ntot),b(q,m),
     /     wk(q,nmax,m),vh(nmax,nmax,m),wkq3(q,q),w(nmax,nmax,m),
     /     xtw(p,nmax),xtwx(p,p),xtwy(p),xtwxinv(p,p)
C initialize W_i to inv(V_i) and  get beta
      do 10 i=1,p
         xtwy(i)=dble(0.)
         do 5 j=i,p
            xtwx(i,j)=dble(0.)
 5       continue
 10   continue
      do 100 s=1,m
         st=ist(s)
         fin=ifin(s)
         do 12 i=st,fin
            do 11 j=i,fin
               if(iflag.ne.1) then
                  w(occ(i),occ(j),s)=vi(occ(i),occ(j),s)
               else
                  if(i.eq.j) then
                     w(occ(i),occ(j),s)=dble(1.)
                  else
                     w(occ(i),occ(j),s)=dble(0.)
                  endif
               endif
 11         continue
 12      continue
         call mkxtw(ntot,pcol,pred,p,xcol,occ,st,fin,nmax,w,xtw,s,m)
         call mkxtwx(ntot,pcol,pred,p,xcol,occ,st,fin,nmax,xtw,xtwx)
         call mkxtwy(ntot,p,xcol,occ,st,fin,nmax,xtw,y,xtwy)
 100  continue
      call chfc(p,p,xtwx)
      call bkslv(p,p,xtwx)
      call mm(p,p,xtwx,xtwxinv)
      do 130 i=1,p
         sum=dble(0.)
         do 110 j=1,i
            sum=sum+xtwxinv(j,i)*xtwy(j)
 110     continue
         do 120 j=i+1,p
            sum=sum+xtwxinv(i,j)*xtwy(j)
 120     continue
         beta(i)=sum
 130  continue
C get sigma2
      call mkdel(ntot,pcol,pred,p,xcol,y,beta,delta)
      sigma2=dble(0.)
      do 300 s=1,m
         st=ist(s)
         fin=ifin(s)
         if(iflag.ne.1) then
            do 200 i=st,fin
               sum1=dble(0.)
               do 190 j=st,i
                  sum1=sum1+delta(j)*vh(occ(j),occ(i),s)
 190            continue
               sigma2=sigma2+sum1**2
 200        continue
         else
            do 210 i=st,fin
               sigma2=sigma2+delta(i)**2
 210        continue
         endif
 300  continue
      sigma2=sigma2/dfloat(ntot)
      return
      end
C***********************************************************************
      subroutine mkb(q,nmax,m,wk,ntot,delta,b,occ,ist,ifin)
C calculates bwig from wk and delta
      integer q,nmax,m,ntot,occ(ntot),ist(m),ifin(m),s,st,fin
      double precision wk(q,nmax,m),delta(ntot),b(q,m),sum
      do 500 s=1,m
         do 400 i=1,q
            st=ist(s)
            fin=ifin(s)
            sum=dble(0.)
            do 300 j=st,fin
               sum=sum+wk(i,occ(j),s)*delta(j)
 300           continue
            b(i,s)=sum
 400     continue
 500  continue
      return
      end
C***********************************************************************
      subroutine ecme3(ntot,subj,m,ist,ifin,occ,nmax,vi,vh,pcol,
     /     pred,q,zcol,ztv,sig0,iflag,sig,psi,sigma2,p,xcol,beta,wkq1,
     /     wkq2,wkq3,y,delta,b,wk,w,xtw,xtwx,xtwy,xtwxinv,llk,vmax,
     /     sflag,eps,obeta,opsi,maxits,iter,cvgd)
C set sflag=1 if starting values supplied
      integer ntot,m,ist(m),ifin(m),occ(ntot),nmax,pcol,
     /     q,zcol(q),iflag,p,xcol(p),sflag,c1,c2,c3,maxits,
     /     iter,cvgd,subj(ntot)
      double precision vi(nmax,nmax,m),pred(ntot,pcol),
     /     ztv(q,nmax,m),sig0(q,q,m),sig(q,q,m),psi(q,q),sigma2,
     /     beta(p),wkq1(q,q),wkq2(q,q),y(ntot),delta(ntot),b(q,m),
     /     wk(q,nmax,m),vh(nmax,nmax,m),wkq3(q,q),w(nmax,nmax,m),
     /     xtw(p,nmax),xtwx(p,p),xtwy(p),xtwxinv(p,p),ll,llk(maxits),
     /     ldxi,ldsig,vmax(nmax,nmax),eps,obeta(p),opsi(q,q),osigma2
      call prelim(ntot,subj,m,ist,ifin,occ,nmax,vmax,vh,vi,pcol,
     /     pred,q,zcol,ztv,sig0,iflag)
      if(sflag.ne.1) then
         call stval(ntot,m,ist,ifin,occ,nmax,vi,vh,pcol,
     /        pred,q,zcol,ztv,sig0,iflag,sig,psi,sigma2,p,xcol,beta,
     /        wkq1,wkq2,wkq3,y,delta,b,wk,w,xtw,xtwx,xtwy,xtwxinv)
      else
         call mkdel(ntot,pcol,pred,p,xcol,y,beta,delta)
      endif
      iter=0
      cvgd=0
 1    continue
         iter=iter+1
         do 2 i=1,p
            obeta(i)=beta(i)
 2       continue
         do 10 i=1,q
            do 5 j=i,q
               opsi(i,j)=psi(i,j)
               wkq3(i,j)=psi(i,j)/sigma2
 5          continue
 10      continue
         osigma2=sigma2
         call mksig3(q,wkq3,m,sig0,sig,wkq1,wkq2,ldxi,ldsig)
         call mkwk3(q,m,sig,nmax,ztv,wk,ntot,occ,ist,ifin)
         call mkb(q,nmax,m,wk,ntot,delta,b,occ,ist,ifin)
         call mkxi(q,m,b,sig,wkq3,sigma2)
         do 20 i=1,q
            do 15 j=i,q
               psi(i,j)=wkq3(i,j)*sigma2
               if(i.ne.j)  psi(j,i)=psi(i,j)
 15         continue
 20      continue
         call mkbeta3(q,nmax,m,wk,ztv,vi,w,ntot,occ,ist,ifin,
     /        pcol,pred,p,xcol,y,xtw,xtwx,xtwy,xtwxinv,beta,iflag)
         call mkdel(ntot,pcol,pred,p,xcol,y,beta,delta)
         call mksig23(ntot,delta,m,sigma2,nmax,vh,occ,ist,ifin,w)
         ll=-dble(.5)*dfloat(ntot)*dlog(sigma2)+dfloat(m)*ldxi+ldsig
         ll=ll-dble(.5)*dfloat(ntot)
         llk(iter)=ll
         c1=0
         do 30 i=1,p
            if(dabs(beta(i)-obeta(i)).gt.(eps*dabs(obeta(i)))) c1=1
 30      continue
         c2=0
         do 40 i=1,q
            do 35 j=i,q
               if(dabs(psi(i,j)-opsi(i,j)).gt.(eps*dabs(opsi(i,j))))
     /              c2=1
 35         continue
 40      continue
         c3=0
         if(dabs(sigma2-osigma2).gt.(eps*dabs(osigma2))) c3=1
         if((c1.eq.0).and.(c2.eq.0).and.(c3.eq.0)) cvgd=1
         if((cvgd.eq.0).and.(iter.lt.maxits)) goto 1
      return
      end
C***********************************************************************
      subroutine mkw3(q,nmax,m,wk,ztv,vi,s,w,ntot,occ,st,fin,iflag)
C for ECME-3
C makes (upper triangular part of) weight matrix w for subject s
      integer q,nmax,m,s,ntot,occ(ntot),st,fin,iflag
      double precision wk(q,nmax,m),ztv(q,nmax,m),vi(nmax,nmax,m),
     /     w(nmax,nmax,m),sum
      if(iflag.ne.1) then
         do 300 i=st,fin
            do 200 j=i,fin
               sum=dble(0.)
               do 100 k=1,q
                  sum=sum+ztv(k,occ(i),s)*wk(k,occ(j),s)
 100           continue
               w(occ(i),occ(j),s)=(vi(occ(i),occ(j),s)-sum)
 200        continue
 300     continue
      else
         do 600 i=st,fin
            do 500 j=i,fin
               sum=dble(0.)
               do 400 k=1,q
                  sum=sum+ztv(k,occ(i),s)*wk(k,occ(j),s)
 400           continue
               if(i.eq.j) then
                  w(occ(i),occ(j),s)=(dble(1.)-sum)
               else
                  w(occ(i),occ(j),s)=-sum
               endif
 500        continue
 600     continue
      endif
      return
      end
C***********************************************************************
      subroutine mkll(nmax,m,w,ntot,delta,occ,ist,ifin,ll,ldpsi,ldsig,
     /     sigma2)
C Calculates loglikelihood value given w, delta, sigma2. Assumes that 
C  -.5*logdet(psi) is in ldpsi, and +.5*sum(logdet(sig_i)) is in ldsig.
      integer nmax,m,ntot,occ(ntot),ist(m),ifin(m),s,st,fin
      double precision w(nmax,nmax,m),delta(ntot),ll,sum,ldpsi,ldsig,
     /     sigma2
      ll=dble(0.)
      do 900 s=1,m
         st=ist(s)
         fin=ifin(s)
         do 300 i=st,fin
            sum=dble(0.)
            do 100 j=st,i
               sum=sum+delta(j)*w(occ(j),occ(i),s)
 100        continue
            do 200 j=i+1,fin
               sum=sum+delta(j)*w(occ(i),occ(j),s)
 200        continue
            ll=ll+sum*delta(i)
 300     continue
 900  continue
      ll=-dble(.5)*ll-dble(.5)*dfloat(ntot)*dlog(sigma2)
      ll=ll+dfloat(m)*ldpsi+ldsig
      return
      end
C***********************************************************************
      subroutine mkbeta3(q,nmax,m,wk,ztv,vi,w,ntot,occ,ist,ifin,
     /     pcol,pred,p,xcol,y,xtw,xtwx,xtwy,xtwxinv,beta,iflag)
C for ECME-3
      integer q,nmax,m,s,ntot,occ(ntot),ist(m),ifin(m),st,fin,p,pcol,
     /     xcol(p),iflag
      double precision wk(q,nmax,m),ztv(q,nmax,m),vi(nmax,nmax,m),
     /     w(nmax,nmax,m),pred(ntot,pcol),xtw(p,nmax),
     /     xtwx(p,p),xtwy(p),beta(p),y(ntot),xtwxinv(p,p),sum
      do 10 i=1,p
         xtwy(i)=dble(0.)
         do 5 j=i,p
            xtwx(i,j)=dble(0.)
 5       continue
 10   continue
      do 100 s=1,m
         st=ist(s)
         fin=ifin(s)
         call mkw3(q,nmax,m,wk,ztv,vi,s,w,ntot,occ,st,fin,iflag)
         call mkxtw(ntot,pcol,pred,p,xcol,occ,st,fin,nmax,w,xtw,s,m)
         call mkxtwx(ntot,pcol,pred,p,xcol,occ,st,fin,nmax,xtw,xtwx)
         call mkxtwy(ntot,p,xcol,occ,st,fin,nmax,xtw,y,xtwy)
 100  continue
      call chfc(p,p,xtwx)
      call bkslv(p,p,xtwx)
      call mm(p,p,xtwx,xtwxinv)
      do 130 i=1,p
         sum=dble(0.)
         do 110 j=1,i
            sum=sum+xtwxinv(j,i)*xtwy(j)
 110     continue
         do 120 j=i+1,p
            sum=sum+xtwxinv(i,j)*xtwy(j)
 120     continue
         beta(i)=sum
 130  continue
      return
      end
C***********************************************************************
      subroutine mkxtwy(ntot,p,xcol,occ,st,fin,nmax,xtw,y,xtwy)
C increments xtwy for subject s
      integer ntot,p,xcol(p),occ(ntot),st,fin,nmax
      double precision xtw(p,nmax),y(ntot),xtwy(p),sum
      do 200 i=1,p
         sum=dble(0.)
         do 100 j=st,fin
            sum=sum+xtw(i,occ(j))*y(j)
 100     continue
         xtwy(i)=xtwy(i)+sum
 200  continue
      return
      end
C***********************************************************************
      subroutine mkxtwx(ntot,pcol,pred,p,xcol,occ,st,fin,nmax,xtw,xtwx)
C increments xtwx for subject s
      integer ntot,pcol,p,xcol(p),occ(ntot),st,fin,nmax
      double precision pred(ntot,pcol),xtw(p,nmax),xtwx(p,p),sum
      do 300 i=1,p
         do 200 j=i,p
            sum=dble(0.)
            do 100 k=st,fin
               sum=sum+xtw(i,occ(k))*pred(k,xcol(j))
 100        continue
            xtwx(i,j)=xtwx(i,j)+sum
 200     continue
 300  continue
      return
      end
C***********************************************************************
      subroutine mkxtw(ntot,pcol,pred,p,xcol,occ,st,fin,nmax,w,xtw,s,m)
      integer ntot,pcol,p,xcol(p),occ(ntot),st,fin,nmax,s,m
      double precision pred(ntot,pcol),w(nmax,nmax,m),xtw(p,nmax),sum
      do 500 i=1,p
         do 400 j=st,fin
            sum=dble(0.)
            do 200 k=st,j
               sum=sum+pred(k,xcol(i))*w(occ(k),occ(j),s)
 200        continue
            do 300 k=j+1,fin
               sum=sum+pred(k,xcol(i))*w(occ(j),occ(k),s)
 300        continue
            xtw(i,occ(j))=sum
 400     continue
 500  continue
      return
      end
C***********************************************************************
      subroutine mkxi(q,m,b,sig,xi,sigma2)
C calculates new estimate of xi from b, sig, and sigma2
      integer q,m,s
      double precision b(q,m),sig(q,q,m),xi(q,q),sigma2
      do 10 i=1,q
         do 5 j=i,q
            xi(i,j)=dble(0.)
 5       continue
 10   continue
      do 100 s=1,m
         do 90 i=1,q
            do 80 j=i,q
               xi(i,j)=xi(i,j)+sig(i,j,s)+b(i,s)*b(j,s)/sigma2
 80         continue
 90      continue
 100  continue
      do 110 i=1,q
         do 105 j=i,q
            xi(i,j)=xi(i,j)/dfloat(m)
 105     continue
 110  continue
      return
      end
C***********************************************************************
      subroutine mkwk3(q,m,sig,nmax,ztv,wk,ntot,occ,ist,ifin)
C Version of mkwk for ECME-3
      integer q,m,nmax,occ(ntot),ist(m),ifin(m),st,fin,s
      double precision sig(q,q,m),ztv(q,nmax,m),wk(q,nmax,m),sum
      do 400 s=1,m
         st=ist(s)
         fin=ifin(s)
         do 300 i=1,q
            do 200 j=st,fin
               sum=dble(0.)
               do 50 k=1,i-1
                  sum=sum+sig(k,i,s)*ztv(k,occ(j),s)
 50            continue
               do 100 k=i,q
                  sum=sum+sig(i,k,s)*ztv(k,occ(j),s)
 100           continue
               wk(i,occ(j),s)=sum
 200        continue
 300     continue
 400  continue
      return
      end
C***********************************************************************
      subroutine mkv(m,nmax,vmax,ntot,occ,ist,ifin,v)
C makes array of submatrices of vmax
      integer m,nmax,ntot,occ(ntot),ist(m),ifin(m),s
      double precision vmax(nmax,nmax),v(nmax,nmax,m)
      do 100 s=1,m
         do 90 i=ist(s),ifin(s)
            do 80 j=i,ifin(s)
               v(occ(i),occ(j),s)=vmax(occ(i),occ(j))
 80         continue
 90      continue
 100  continue
      return
      end
C***********************************************************************
      subroutine chv(nmax,m,v,ntot,occ,ist,ifin)
C overwrites v with its cholesky factors
      integer nmax,m,ntot,occ(ntot),ist(m),ifin(m),s
      double precision v(nmax,nmax,m),sum
      do 100 s=1,m
         do 50 i=ist(s),ifin(s)
            sum=dble(0.)
            do 10 k=ist(s),i-1
               sum=sum+v(occ(k),occ(i),s)**2
 10         continue
            v(occ(i),occ(i),s)=dsqrt(v(occ(i),occ(i),s)-sum)
            do 40 j=i+1,ifin(s)
               sum=dble(0.)
               do 30 k=ist(s),i-1
                  sum=sum+v(occ(k),occ(i),s)*v(occ(k),occ(j),s)
 30            continue
               v(occ(i),occ(j),s)=(v(occ(i),occ(j),s)-sum)/
     /              v(occ(i),occ(i),s)
 40         continue
 50      continue
 100  continue
      return
      end
C***********************************************************************
      subroutine bkv(nmax,m,v,ntot,occ,ist,ifin)
C inverts upper-triangular portions of v by backsolve
      integer nmax,m,ntot,occ(ntot),ist(m),ifin(m),s,st,fin
      double precision v(nmax,nmax,m),sum
      do 100 s=1,m
         st=ist(s)
         fin=ifin(s)
         v(occ(st),occ(st),s)=dble(1.)/v(occ(st),occ(st),s)
         do 10 k=st+1,fin
            v(occ(k),occ(k),s)=dble(1.)/v(occ(k),occ(k),s)
            do 5 j=st,k-1
               sum=dble(0.)
               do 3 i=j,k-1
                  sum=sum+v(occ(j),occ(i),s)*v(occ(i),occ(k),s)
 3             continue
               v(occ(j),occ(k),s)=-sum*v(occ(k),occ(k),s)
 5          continue
 10      continue
 100  continue
      return
      end
C***********************************************************************
      subroutine mmu(ntot,pcol,pred,q,zcol,nmax,m,v,occ,ist,ifin,ztv,
     /     iflag)
C multiplies z^t by upper-triangular v, stores result in ztv
      integer ntot,pcol,q,zcol(q),nmax,m,occ(ntot),ist(m),ifin(m),s,
     /     st,fin,iflag
      double precision pred(ntot,pcol),v(nmax,nmax,m),ztv(q,nmax,m),
     /     sum
      if(iflag.ne.1) then
         do 300 s=1,m
            st=ist(s)
            fin=ifin(s)
            do 200 i=1,q
               do 100 j=st,fin
                  sum=dble(0.)
                  do 50 k=st,j
                     sum=sum+pred(k,zcol(i))*v(occ(k),occ(j),s)
 50               continue
                  ztv(i,occ(j),s)=sum
 100           continue
 200        continue
 300     continue
      else
         do 600 s=1,m
            st=ist(s)
            fin=ifin(s)
            do 500 i=1,q
               do 400 j=st,fin
                  ztv(i,occ(j),s)=pred(j,zcol(i))
 400           continue
 500        continue
 600     continue
      endif
      return
      end
C***********************************************************************
      subroutine mml(ntot,q,nmax,m,v,occ,ist,ifin,ztv)
C multiplies ztv by lower-triangular v, stores result in ztv
      integer ntot,q,nmax,m,occ(ntot),ist(m),ifin(m),s,st,fin
      double precision v(nmax,nmax,m),ztv(q,nmax,m),sum
      do 300 s=1,m
         st=ist(s)
         fin=ifin(s)
         do 200 i=1,q
            do 100 j=st,fin
               sum=dble(0.)
               do 50 k=j,fin
                  sum=sum+ztv(i,occ(k),s)*v(occ(j),occ(k),s)
 50            continue
               ztv(i,occ(j),s)=sum
 100        continue
 200     continue
 300  continue
      return
      end
C***********************************************************************
      subroutine mmulv(nmax,m,vh,vi,ntot,occ,ist,ifin)
C calculates upper tri part of vi = vh%*%t(vh), where vh is upper tri
C(works in layers s=1,...,m)
      integer nmax,m,ntot,occ(ntot),ist(m),ifin(m),s,st,fin
      double precision vh(nmax,nmax,m),vi(nmax,nmax,m),sum
      do 300 s=1,m
         st=ist(s)
         fin=ifin(s)
         do 200 i=st,fin
            do 100 j=i,fin
               sum=dble(0.)
               do 50 k=max(i,j),fin
                  sum=sum+vh(occ(i),occ(k),s)*vh(occ(j),occ(k),s)
 50            continue
               vi(occ(i),occ(j),s)=sum
 100        continue
 200        continue
 300  continue
      return
      end
C***********************************************************************
      subroutine mmtm(q,nmax,m,ztv,ntot,occ,ist,ifin,sig0)
C multiply ztv by its transpose, store result (upper-tri part) in sig0
      integer q,nmax,m,ntot,occ(ntot),ist(m),ifin(m),s
      double precision ztv(q,nmax,m),sig0(q,q,m),sum
      do 500 s=1,m
         do 400 i=1,q
            do 300 j=i,q
               sum=dble(0.)
               do 200 k=ist(s),ifin(s)
                  sum=sum+ztv(i,occ(k),s)*ztv(j,occ(k),s)
 200           continue
               sig0(i,j,s)=sum
 300        continue
 400     continue
 500  continue
      return
      end
C***********************************************************************
      subroutine mksig23(ntot,delta,m,sigma2,nmax,vh,occ,ist,ifin,w)
C for ECME-3
      integer ntot,m,s,nmax,occ(ntot),ist(m),ifin(m),st,fin
      double precision delta(ntot),sigma2,sum,w(nmax,nmax,m)
      sigma2=dble(0.)
      do 900 s=1,m
         st=ist(s)
         fin=ifin(s)
         do 300 i=st,fin
            sum=dble(0.)
            do 100 j=st,i
               sum=sum+delta(j)*w(occ(j),occ(i),s)
 100        continue
            do 200 j=i+1,fin
               sum=sum+delta(j)*w(occ(i),occ(j),s)
 200        continue
            sigma2=sigma2+sum*delta(i)
 300     continue
 900  continue
      sigma2=sigma2/dfloat(ntot)
      return
      end
C***********************************************************************
      subroutine mkdel(ntot,pcol,pred,p,xcol,y,beta,delta)
      integer ntot,p,xcol(p),pcol
      double precision pred(ntot,pcol),y(ntot),beta(p),delta(ntot),sum
      do 100 i=1,ntot
         sum=dble(0.)
         do 70 j=1,p
            sum=sum+pred(i,xcol(j))*beta(j)
 70      continue
         delta(i)=y(i)-sum
 100  continue
      return
      end
C***********************************************************************
      subroutine mksig3(q,xi,m,sig0,sig,wkq1,wkq2,ldxi,ldsig)
C Version of mksig for ECME-3. Given xi=psi/sigma2.
C After execution, xi contains the inverse cholesky factor
C of the original xi, and wkq1 contains the inverse of the original
C xi (upper-tri part only).
C Also calculates ldxi = -.5*logdet(xi) and
C                 ldsig = +.5*sum( logdet(sig_i) ), i=1,...,m
      integer q,m,s
      double precision xi(q,q),sig0(q,q,m),sig(q,q,m),
     /     wkq1(q,q),wkq2(q,q),ldxi,ldsig
C invert xi 
      call chfc(q,q,xi)
      call bkslv(q,q,xi)
      ldxi=dble(0.)
      do 1 i=1,q
         ldxi=ldxi+dlog(xi(i,i))
 1    continue
      call mm(q,q,xi,wkq1)
      ldsig=dble(0.)
      do 500 s=1,m
         do 100 i=1,q
            do 80 j=i,q
               sig(i,j,s)=wkq1(i,j)+sig0(i,j,s)
 80         continue
 100     continue
         call chl(q,q,m,sig,s)
         call bkslvl(q,q,m,sig,s)
         do 110 i=1,q
            ldsig=ldsig+dlog(sig(i,i,s))
 110     continue
         call mmul(q,q,m,sig,s,wkq2)
         do 200 i=1,q
            do 150 j=i,q
               sig(i,j,s)=wkq2(i,j)
 150        continue
 200     continue
 500  continue
      return
      end
C***********************************************************************
      subroutine bdiag(q,m,sig)
C fills in elements of each layer of sig below the diagonal
      integer q,m,s
      double precision sig(q,q,m)
      do 10 s=1,m
         do 5 i=1,q
            do 1 j=1,i-1
               sig(i,j,s)=sig(j,i,s)
 1          continue
 5       continue
 10   continue
      return
      end
C***********************************************************************
